         title   Assembler Calculator DLL
         comment '======================================================|'
         comment '* EWCalc v1.0                                         *'
         comment '* Copyright (r) Ewayne L. Wagner, All Rights Reserved.*'
         comment '* Unless you can improve on the program and send me   *'
         comment '* the changes. yooper@kalamazoo.net                   *'
         comment '======================================================|'

            .586
            .model   flat, STDCALL
            option casemap :none  ; case sensitive

            include  Windows.inc
            include  user32.inc
            include  kernel32.inc
            include  gdi32.inc
            include  comctl32.inc

            include  L:\AsmEdit\include\DSPMACRO.asm

         includelib  user32.lib
         includelib  kernel32.lib
         includelib  gdi32.lib
         includelib  comctl32.lib

WinMain         PROTO           :DWORD, :DWORD, :DWORD, :DWORD
WinProc         PROTO           :DWORD, :DWORD, :DWORD, :DWORD
EditProc        PROTO           :DWORD, :DWORD, :DWORD, :DWORD
ToolbarProc     PROTO           :DWORD, :DWORD, :DWORD, :DWORD
CLRMW           PROTO           :DWORD, :DWORD           
CopyMW          PROTO           :DWORD, :DWORD, :DWORD
CompMW          PROTO           :DWORD, :DWORD, :DWORD
MOVem           PROTO           :DWORD, :DWORD
;wsprintfA       PROTO C :DWORD,:VARARG
;wsprintf        equ <wsprintfA>

MOVmd       MACRO Var1, Var2
                 push     Var2
                  pop     Var1
            ENDM

.const
IDI_ICON1       EQU 101
IDR_MENU1       EQU 102
IDB_BUT07       EQU 207
IDB_BUT08       EQU 208
IDB_BUT09       EQU 209
IDB_BUTADD      EQU 218
IDB_BUTSQ       EQU 223
IDB_BUT04       EQU 204
IDB_BUT05       EQU 205
IDB_BUT06       EQU 206
IDB_BUTSUB      EQU 219
IDB_BUTPCT      EQU 224
IDB_BUT01       EQU 201
IDB_BUT02       EQU 202
IDB_BUT03       EQU 203
IDB_BUTMUL      EQU 220
IDB_BUTPOW      EQU 225
IDB_BUT00       EQU 200
IDB_BUTPER      EQU 216
IDB_BUTEQ       EQU 222
IDB_BUTDIV      EQU 221
IDB_BUTPM       EQU 217
IDB_BUTA        EQU 210
IDB_BUTB        EQU 211
IDB_BUTC        EQU 212
IDB_BUTD        EQU 213
IDB_BUTE        EQU 214
IDB_BUTF        EQU 215
IDB_BUTMC       EQU 226
IDB_BUTMR       EQU 227
IDB_BUTMS       EQU 228
IDB_BUTMP       EQU 229
IDB_BUTMM       EQU 230
IDB_BUTHYP      EQU 231
IDB_BUTREC      EQU 232
IDB_BUTXN       EQU 233
IDB_BUTPI       EQU 234
IDB_BUTSIN      EQU 235
IDB_BUTCOS      EQU 236
IDB_BUTTAN      EQU 237
IDB_BUTCSC      EQU 238
IDB_BUTSEC      EQU 239
IDB_BUTCOT      EQU 240
IDB_BUTLOG      EQU 241
IDB_BUT2X       EQU 242
IDB_BUT10X      EQU 243
IDB_BUTEX       EQU 244

B1              EQU 500

IDD_INFO        EQU 1999
IDD_ABOUT       EQU 2000
IDD_CALC        EQU 2102
IDM_CLOSE       EQU 6003
IDM_CUT         EQU 6004
IDM_COPY        EQU 6005
IDM_PASTE       EQU 6006
IDM_INFO        EQU 6026
IDM_ABOUT       EQU 6027
IDT_TOOLBAR1    EQU 301
IDT_TOOLBAR2    EQU 302
IDT_TOOLBAR3    EQU 303
IDT_TOOLBAR4    EQU 304
IDT_TOOLBAR5    EQU 305

.const
IDI_ICON1       EQU 101
IDR_MENU1       EQU 102
IDB_BUT07       EQU 207
IDB_BUT08       EQU 208
IDB_BUT09       EQU 209
IDB_BUTADD      EQU 218
IDB_BUTSQ       EQU 223
IDB_BUT04       EQU 204
IDB_BUT05       EQU 205
IDB_BUT06       EQU 206
IDB_BUTSUB      EQU 219
IDB_BUTPCT      EQU 224
IDB_BUT01       EQU 201
IDB_BUT02       EQU 202
IDB_BUT03       EQU 203
IDB_BUTMUL      EQU 220
IDB_BUTPOW      EQU 225
IDB_BUT00       EQU 200
IDB_BUTPER      EQU 216
IDB_BUTEQ       EQU 222
IDB_BUTDIV      EQU 221
IDB_BUTPM       EQU 217
IDB_BUTA        EQU 210
IDB_BUTB        EQU 211
IDB_BUTC        EQU 212
IDB_BUTD        EQU 213
IDB_BUTE        EQU 214
IDB_BUTF        EQU 215
IDB_BUTMC       EQU 226
IDB_BUTMR       EQU 227
IDB_BUTMS       EQU 228
IDB_BUTMP       EQU 229
IDB_BUTMM       EQU 230
IDB_BUTHYP      EQU 231
IDB_BUTREC      EQU 232
IDB_BUTXN       EQU 233
IDB_BUTPI       EQU 234
IDB_BUTSIN      EQU 235
IDB_BUTCOS      EQU 236
IDB_BUTTAN      EQU 237
IDB_BUTCSC      EQU 238
IDB_BUTSEC      EQU 239
IDB_BUTCOT      EQU 240
IDB_BUTLOG      EQU 241
IDB_BUT2X       EQU 242
IDB_BUT10X      EQU 243
IDB_BUTEX       EQU 244

B1              EQU 500

IDD_INFO        EQU 1999
IDD_ABOUT       EQU 2000
IDD_CALC        EQU 2102
IDM_CLOSE       EQU 6003
IDM_CUT         EQU 6004
IDM_COPY        EQU 6005
IDM_PASTE       EQU 6006
IDM_INFO        EQU 6026
IDM_ABOUT       EQU 6027
IDT_TOOLBAR1    EQU 301
IDT_TOOLBAR2    EQU 302
IDT_TOOLBAR3    EQU 303
IDT_TOOLBAR4    EQU 304
IDT_TOOLBAR5    EQU 305

.data
FontName        db  'Courier New',0
FontNamep       db  'Courier',0
FontName1       db  'Times New Roman',0
FmtA            db  '%lu',0        ; output as ascii string
FmtH            db  '%lX',0        ; output as hex UC
Clear           db  50  dup(' ')
Zeros           db  64  dup('0')
AppName         db  'ASM CALCULATOR',0
class           db  'Calculator',0
TB02class       db  'TB01',0
ToolClass       db  'ToolbarWindow32',0
ErrorMsg        db  '** The output is out of range **            ',0
szPaste         db  'Your Paste Selection Is Out Of'
                db  0Dh,0Ah
                db  'Range For The Base Setting!',0
TB              db  ' CALCULATOR V1.0 DLL Written in Assembler',0

Info            db  38 dup(' ')
                db  'Most of the functions are self explanatory.'
                db  0Dh,0Ah,0Dh,0Ah
                db  'There Are Three Two Step Functions.'
                db  0Dh,0Ah
                db  '(1). X**n  Enter the base number click the X**n button enter the exponent click =.'
                db  0Dh,0Ah
                db  '(2). HYP  Enter the X number click the HYP button enter the Y number click =.'
                db  0Dh,0Ah
                db  '(3). %  Enter the first number click the X button enter the second number click %.'
                db  0Dh,0Ah
                db  'Or Enter the first number click the +,-,x or div button enter the % number '
                db  'click % click =.',0

EditPT          db  'EDIT',0
Butt            db  'BUTTON',0
Stat            db  'STATIC',0 
ButtT1          db  'Push',0
float           db  'Floating Point',0
arc             db  'Arc',0
BackS           db  'Back Space',0
CE              db  'CE',0
CLR             db  'C',0
DegT            db  'Deg',0
RadT            db  'Rad',0
DecT            db  'Dec',0
HexT            db  'Hex',0
OctT            db  'Oct',0
BinT            db  'Bin',0
Pi              db  '3.141592653589793238',0  ;4626433832795',0
Period          db  '.',0
Zero            db  '0',0
One             db  '1',0
M               db  'M',0
S               db  '-',0
PO              db  '+',0
SO              db  '-',0
MO              db  'x',0
DO              db  '/',0
EO              db  '=',0
operator        db  ?
Work            dd  0
I               dd  0
N               dd  0
T               dd  1 
W               dd  0
Base            dd  10

CW            WORD  10
CWRound       WORD  037fh
CWNoRound     WORD  0f7fh
RNum10      REAL10  ?
RWrk10      REAL10  ?
RMem10      REAL10  ?
RDeg10      REAL10  0.01745329252
RRad10      REAL10  57.2957795130
Temp10      REAL10  ?
QW              dq  0
; dwords (1 - 4 Intergers) (5 - 8 Decimals)
; (9 = Num of intergers) (10 = Num of decimals)
; (11 = Num of leading zeros) (12 = Minus)
A               dd  0,0,0,0,0,0,0,0
B               dd  0,0,0,0,0,0,0,0
D               dd  0,0,0,0,0,0,0,0,0,0,0,0
R               dd  0,0,0,0,0,0,0,0,0,0,0,0
R1              dd  0,0,0,0
R2              dd  0,0,0,0
R3              dd  0,0,0,0
R4              dd  0,0,0,0,0,0,0,0
R5              dd  0,0,0,0,0,0,0,0,0,0
PT              dd  0,0,0,0,0,0,0,0,0,0,0,0
MEM             dd  0,0,0,0,0,0,0,0,0,0,0,0
Sav             dd  0,0,0,0,0,0,0,0,0,0,0,0
RH              dd  0,0,0,0,0,0,0,0,0,0,0,0
Modulo          dd  0 
HeadC           dd  00ff0000h 
TextC           dd  00000000h 
BackGC          dd  00b1987ch

.data?
hInst           dd  ?
hSave           dd  ?
hWnd            dd  ?
hMenu           dd  ?
hAccel          dd  ?
hFont           dd  ?
hDspF           dd  ?
hFontDL         dd  ?
CommandLine     dd  ?
hEDC            dd  ?
hEdit           dd  ?
hDspl           dd  ?
hFloat          dd  ?
hArc            dd  ?
hMem            dd  ?
hBkSp           dd  ?
hOpr            dd  ?
hCE             dd  ?
hCLR            dd  ?
hDeg            dd  ?
hRad            dd  ?
hDec            dd  ?
hHex            dd  ?
hOct            dd  ?
hBin            dd  ?
hTB01           dd  ?
hTB02           dd  ?
hTB03           dd  ?
hTB04           dd  ?
hTB05           dd  ?
hBrush          dd  ?
SubEdit         dd  ?
SubTool         dd  ?
sebx            dd  ?
sedi            dd  ?
sesi            dd  ?
Float           dd  ?
First           dd  ?
sw1             dd  ?
sw2             dd  ?
sw3             dd  ?
Min             dd  ?
Key             dd  ?
HPress          dd  ?
NPress          dd  ?
RPress          dd  ?
BPress          dd  ?
Branch          dd  ? 
Len             dd  ?
HLen            dd  ?
w1              dd  ?
w2              dd  ?
XP              dd  ?
YP              dd  ?
cnt             dd  ?
ArcOn           dd  ?
NoFix           dd  ?
cpy             dd  ?
Row             dd  ?
Col             dd  ?
Pos             dd  ?
DecPos          dd  ?
DP              dd  ?
FPLZ            dd  ?
PassDec         dd  ?
HBase           dd  ?
PrevBase        dd  ?
StoreFlag       dd  ?
SubZero         dd  ?
hDLL            dd  ?
PLBuff          db  50  dup(?)
PRBuff          db  50  dup(?)
HLBuff          db  50  dup(?)
HRBuff          db  50  dup(?)
LBuff           db  50  dup(?)
RBuff           db  50  dup(?)
ConvH           db  120 dup(?)
ConvI           db  120 dup(?)
ConvO           db  120 dup(?)
Buff            db  120 dup(?)

Test44          dd  ?

.data
IDT             dd  IDT_TOOLBAR1,IDT_TOOLBAR2,IDT_TOOLBAR3,IDT_TOOLBAR4,IDT_TOOLBAR5

tb1      TBBUTTON    <0,IDB_BUTSIN,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <1,IDB_BUTCOT,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <2,IDB_BUTMC,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <3,IDB_BUT07,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <4,IDB_BUT08,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <5,IDB_BUT09,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <6,IDB_BUTADD,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <7,IDB_BUTSQ,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
tbb1     TBBUTTON    <8,IDB_BUTHYP,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
tbl1     EQU         ($-tbb1)

tb2      TBBUTTON    <0,IDB_BUTCOS,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <1,IDB_BUTLOG,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <2,IDB_BUTMR,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <3,IDB_BUT04,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <4,IDB_BUT05,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <5,IDB_BUT06,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <6,IDB_BUTSUB,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <7,IDB_BUTPCT,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
tbb2     TBBUTTON    <8,IDB_BUTREC,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
tbl2     EQU         ($-tbb2)

tb3      TBBUTTON    <0,IDB_BUTTAN,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <1,IDB_BUT2X,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <2,IDB_BUTMS,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <3,IDB_BUT01,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <4,IDB_BUT02,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <5,IDB_BUT03,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <6,IDB_BUTMUL,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <7,IDB_BUTPOW,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
tbb3     TBBUTTON    <8,IDB_BUTXN,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
tbl3     EQU         ($-tbb3)

tb4      TBBUTTON    <0,IDB_BUTCSC,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <1,IDB_BUT10X,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <2,IDB_BUTMP,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <3,IDB_BUT00,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <4,IDB_BUTPER,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <5,IDB_BUTEQ,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <6,IDB_BUTDIV,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <7,IDB_BUTPM,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
tbb4     TBBUTTON    <8,IDB_BUTPI,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
tbl4     EQU         ($-tbb4)

tb5      TBBUTTON    <0,IDB_BUTSEC,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <1,IDB_BUTEX,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <2,IDB_BUTMM,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <3,IDB_BUTA,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <4,IDB_BUTB,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <5,IDB_BUTC,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <6,IDB_BUTD,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
         TBBUTTON    <7,IDB_BUTE,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
         TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
tbb5     TBBUTTON    <8,IDB_BUTF,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
tbl5     EQU         ($-tbb5)
tb       dd  tb1,tb2,tb3,tb4,tb5
tbl      dd  tbl1,tbl2,tbl3,tbl4,tbl5

wc       WNDCLASS     <?>
msg      MSG          <?>
lf       LOGFONT      <?>

.code

DllEntry PROC hinstDLL:DWORD, reason:DWORD, reserve:DWORD
      .if reason == DLL_PROCESS_ATTACH
           push     hinstDLL
            pop     hInst
            mov     eax, TRUE
      .elseif reason == DLL_PROCESS_DETACH
            xor     eax, eax
      .endif
         RET
DllEntry ENDP

;*************************************************************************************      
Calc     PROC  hLib:DWORD
        push     hLib
         pop     hDLL
        call     InitCommonControls ; Initialize the common ctrl lib
      INVOKE     GetCommandLine
         mov     CommandLine, eax
      INVOKE     WinMain, hInst, NULL, CommandLine, SW_SHOWDEFAULT
         RET
Calc     ENDP

;=========================================================================|
;                            WinMain Procedure                            |
;=========================================================================|
WinMain PROC     hinst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD
    ;**********************
    ;*  Initialize the WndClass structure and register the class name
    ;**********************
         mov     wc.style,CS_HREDRAW or CS_VREDRAW or CS_GLOBALCLASS      
         mov     wc.lpfnWndProc,offset WndProc
         mov     wc.cbClsExtra,0
         mov     wc.cbWndExtra,0
         mov     eax,hInst
         mov     wc.hInstance,eax
      INVOKE     LoadIcon, eax, IDI_ICON1   
         mov     wc.hIcon,eax
      INVOKE     LoadCursor, 0, IDC_ARROW   
         mov     wc.hCursor,eax
         mov     wc.hbrBackground,COLOR_BTNFACE+1
         mov     wc.lpszMenuName, 0
         mov     wc.lpszClassName, offset class
      INVOKE     RegisterClass, offset wc

      INVOKE     LoadMenu, hInst, IDR_MENU1   
         mov     hMenu, eax

      INVOKE     CreateWindowEx,0,ADDR class,ADDR TB,
                 WS_OVERLAPPED or WS_CAPTION or WS_SYSMENU or WS_MINIMIZEBOX,
                 200,68,460,262,NULL,hMenu,hinst,NULL  ;450
         mov     hWnd,eax
      INVOKE     ShowWindow, hWnd,SW_SHOWNORMAL
      INVOKE     UpdateWindow, hWnd
      INVOKE     SetWindowPos, hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE or SWP_SHOWWINDOW
      INVOKE     LoadAccelerators, hInst, 2007
         mov     hAccel, eax

BeginLoop:
      INVOKE     GetMessage, offset msg, 0, 0, 0   
         cmp     eax,0
         je      EndLoop
      INVOKE     TranslateAccelerator, hWnd, hAccel, offset msg
         cmp     eax, 0
         jne     BeginLoop
      INVOKE     TranslateMessage, offset msg
      INVOKE     DispatchMessage, offset msg
         jmp     BeginLoop
EndLoop:
         RET
WinMain  ENDP

;=========================================================================|
;                            WinProc Procedure                            |
;=========================================================================|
WndProc  PROC    uses ebx edi esi, hwnd:DWORD, wmsg:DWORD, wparam:DWORD, lparam:DWORD
LOCAL    pt:POINT

         mov     eax,wmsg
         cmp     eax,WM_CREATE
         je      wmcreate
         cmp     eax,WM_COMMAND
         je      wmcommand
         cmp     eax,WM_CLOSE
         je      wmdestroy
         cmp     eax,WM_NOTIFY
         je      wmnotify
         cmp     eax, WM_INITMENUPOPUP
         je      wminitmenupopup
      .if wmsg == WM_KEYDOWN
         INVOKE     SetFocus, hEdit
      .endif
         jmp     defwndproc

wmcommand:
         mov     eax,wparam
         cwde                      ; Only low word contains command
         cmp     eax,IDM_CLOSE
         je      wmdestroy
         cmp     eax,IDM_CUT
         je      idmcut
         cmp     eax,IDM_COPY
         je      idmcopy
         cmp     eax,IDM_PASTE
         je      idmpaste
         cmp     eax,IDM_INFO
         je      idminfo
         cmp     eax,IDM_ABOUT
         je      idmabout
         cmp     eax, 1
         je      wmbs
         cmp     eax, 2
         je      wmce
         cmp     eax, 3
         je      wmclr
      .if eax == 19
            mov     T, 1
         INVOKE     SendMessage, hRad, BM_SETCHECK, BST_UNCHECKED, 0 ; Sets rad to unchecked
      .endif
      .if eax == 20
            mov     T, 2
         INVOKE     SendMessage, hDeg, BM_SETCHECK, BST_UNCHECKED, 0 ; Sets deg to unchecked
      .endif

; -------* 21=Dec * 22=Hex * 23=Oct * 24=Bin *-------
         and     sw2, 0
      .if eax == 21                ; Dec
         .if Base != 10
             MOVmd     PrevBase, Base
               mov     Base, 10
               mov     sw2, 10
              call     DsplyConv 
         .endif
      .endif
      .if eax == 22                ; Hex
         .if Base != 16
             MOVmd     PrevBase, Base
               mov     Base, 16
               mov     sw2, 16
              call     DsplyConv 
         .endif 
      .endif
      .if eax == 23                ; Oct
         .if Base != 8
             MOVmd     PrevBase, Base
               mov     Base, 8
               mov     sw2, 8
              call     DsplyConv
         .endif 
      .endif
      .if eax == 24                ; Bin
         .if Base != 2
             MOVmd     PrevBase, Base
               mov     Base, 2
               mov     sw2, 2
              call     DsplyConv
         .endif 
      .endif
      .if eax > 20 && eax < 25
            and     I, 0
      .endif
      .if eax == 43
            and     Float, 0
         INVOKE     SendMessage, hFloat, BM_GETCHECK, 0, 0
         .if eax == 1
               or     Float, 1
         .endif
            jmp     wmclr
      .endif
      .if eax == 50
            and     ArcOn, 0
         INVOKE     SendMessage, hArc, BM_GETCHECK, 0, 0
         .if eax == 1
               or     ArcOn, 1
         .endif
      .endif
         jmp     defwndproc

wmcreate:
      INVOKE     GetSysColor, COLOR_MENU
         mov     BackGC, eax
      INVOKE     CreateSolidBrush, BackGC              ;Build a solid color brush
         mov     hBrush, eax

      INVOKE     lstrcpy, ADDR lf.lfFaceName, ADDR FontName
         mov     lf.lfHeight, -12
         mov     lf.lfWeight, 500
      INVOKE     CreateFontIndirect, ADDR lf
         mov     hFont, eax

         mov     lf.lfHeight, -11 ;14
         mov     lf.lfWeight, 500
      INVOKE     CreateFontIndirect, ADDR lf
         mov     hFontDL, eax

      INVOKE     lstrcpy, ADDR lf.lfFaceName, ADDR FontName1
         mov     lf.lfHeight, -12
         mov     lf.lfWeight, 500
      INVOKE     CreateFontIndirect, ADDR lf
         mov     hDspF, eax

      INVOKE     CreateWindowEx,NULL, ADDR Butt,ADDR float,
                 WS_CHILD or WS_VISIBLE or BS_AUTOCHECKBOX,
                 4,4,130,12,hwnd,43,hInst,NULL    ; Floating Point
         mov     hFloat, eax
      INVOKE     SendMessage, hFloat, WM_SETFONT, hFont, 0

      INVOKE     CreateWindowEx,WS_EX_CLIENTEDGE, ADDR EditPT,NULL,
                 WS_CHILD or WS_VISIBLE or WS_BORDER or ES_RIGHT or ES_AUTOHSCROLL or ES_SAVESEL,
                 135,0,315,22,hwnd,44,hInst,NULL  ; Edit window
         mov     hEdit,eax
      INVOKE     SetWindowLong, hEdit, GWL_WNDPROC, EditProc
         mov     SubEdit, eax

      INVOKE     CreateWindowEx,NULL, ADDR Butt,ADDR arc,
                 WS_CHILD or WS_VISIBLE or BS_AUTOCHECKBOX,
                 182,32,40,12,hwnd,50,hInst,NULL  ; Arc for trig
         mov     hArc, eax
      INVOKE     SendMessage, hArc, WM_SETFONT, hFont, 0

      INVOKE     CreateWindowEx,WS_EX_CLIENTEDGE, ADDR EditPT,NULL,
                 WS_CHILD or WS_VISIBLE or WS_BORDER or ES_CENTER or ES_READONLY,
                 239,26,25,21,hwnd,88,hInst,NULL  ; Memory window
         mov     hMem,eax

      INVOKE     CreateWindowEx,NULL, ADDR Butt, ADDR BackS,
                 WS_CHILD or WS_VISIBLE,
                 271,26,80,20,hwnd,1,hInst,NULL   ; Backspace button
         mov     hBkSp, eax
      INVOKE     SendMessage, hBkSp, WM_SETFONT, hFont, 0

      INVOKE     CreateWindowEx,WS_EX_CLIENTEDGE, ADDR EditPT,NULL,
                 WS_CHILD or WS_VISIBLE or WS_BORDER or ES_CENTER or ES_READONLY,
                 363,26,25,21,hwnd,89,hInst,NULL  ; Operator window
         mov     hOpr,eax

      INVOKE     CreateWindowEx,NULL, ADDR Butt,ADDR CE,
                 WS_CHILD or WS_VISIBLE,
                 399,26,20,20,hwnd,2,hInst,NULL   ; Clear error button
         mov     hCE, eax
      INVOKE     SendMessage, hCE, WM_SETFONT, hFont, 0

      INVOKE     CreateWindowEx,NULL, ADDR Butt,ADDR CLR,
                 WS_CHILD or WS_VISIBLE,
                 429,26,20,20,hwnd,3,hInst,NULL   ; Clear button
         mov     hCLR, eax
      INVOKE     SendMessage, hCLR, WM_SETFONT, hFont, 0

;--------[ Check boxes and radio buttons ]-----------------------------
      INVOKE     CreateWindowEx,NULL, ADDR Butt,0,
                 WS_CHILD or WS_VISIBLE or BS_GROUPBOX,
                 178,43,85,28,hwnd,14,hInst,NULL  ; Deg & Rad group box

      INVOKE     CreateWindowEx,NULL, ADDR Butt,0,
                 WS_CHILD or WS_VISIBLE or BS_GROUPBOX,
                 271,43,178,28,hwnd,15,hInst,NULL ; Base group box
         xor     ebx, ebx
         mov     XP, 182
         mov     N, 19

BuildRadio:
      .if N < 21
         INVOKE     CreateWindowEx,NULL, ADDR Butt,ADDR DegT[ebx],
                    WS_CHILD or WS_VISIBLE or BS_AUTOCHECKBOX,
                    XP,55,39,12,hwnd,N,hInst,NULL ; Deg & Rad check boxes
            sub     XP, 3
      .else
         INVOKE     CreateWindowEx,NULL, ADDR Butt,ADDR DegT[ebx],
                    WS_CHILD or WS_VISIBLE or BS_AUTORADIOBUTTON,
                    XP,55,40,12,hwnd,N,hInst,NULL ; Base radio buttons
      .endif
         mov     hDeg[ebx], eax
      INVOKE     SendMessage, hDeg[ebx], WM_SETFONT, hFont, 0
      .if N < 24
            add     ebx, 4
            add     N, 1
         .if N == 21
               add     XP, 13
         .endif
            add     XP, 43
            jmp     BuildRadio
      .endif
      INVOKE     SendMessage, hDeg, BM_SETCHECK, BST_CHECKED, 0 ; Sets deg to checked
      INVOKE     SendMessage, hDec, BM_SETCHECK, BST_CHECKED, 0 ; Sets dec to checked

;--------[ Toolbars ]--------------------------------------------------
         xor     ebx, ebx
         mov     XP, 178
         mov     YP, 74
         mov     Row, 0
         mov     I, 9
         mov     N, 17
         mov     W, 272

BuildTB:
      INVOKE     CreateWindowEx,NULL, ADDR Stat, 0,
                 WS_CHILD or WS_VISIBLE,
                 XP,YP,W,24,hwnd,1,hInst,NULL     ; Toolbars   
         mov     hTB01,eax
      INVOKE     SetWindowLong, hTB01, GWL_WNDPROC, ToolbarProc
         mov     SubTool, eax
      INVOKE     CreateToolbarEx,hTB01,WS_CHILD or WS_VISIBLE or CCS_NODIVIDER,
                 IDT[ebx],I, hInst, IDT[ebx], tb[ebx], N, 16, 16, 16, 16, tbl[ebx]
      .if Row < 4
            add     ebx, 4
            add     YP, 29
            add     Row, 1
            jmp     BuildTB
      .endif
         and     I, 0

;--------[ Display area ]----------------------------------------------
      INVOKE     CreateWindowEx,NULL, ADDR Butt,0,
                 WS_CHILD or WS_VISIBLE or BS_GROUPBOX,
                 4,18,161,196,hwnd,55,hInst,NULL  ; Display area
         mov     hDspl, eax
INVOKE     SetFocus, hEdit
         jmp     returnP

wmnotify:
         jmp     returnP

wminitmenupopup:
         INVOKE     SendMessage, hEdit, EM_GETSEL, addr w1, addr w2
            mov     eax, w1
         .if w2 > eax
            INVOKE     EnableMenuItem, hMenu, IDM_CUT, MF_BYCOMMAND or MF_ENABLED
            INVOKE     EnableMenuItem, hMenu, IDM_COPY, MF_BYCOMMAND or MF_ENABLED
         .ELSE
            INVOKE     EnableMenuItem, hMenu, IDM_CUT, MF_BYCOMMAND or MF_GRAYED
            INVOKE     EnableMenuItem, hMenu, IDM_COPY, MF_BYCOMMAND or MF_GRAYED
         .endif
         jmp     returnP

idmcut:
      INVOKE     SendMessage, hEdit, WM_CUT, 0 ,0
         jmp     wmclr

idmcopy:
      INVOKE     SendMessage, hEdit, WM_COPY, 0 ,0
         jmp     returnP

idmpaste:
        call     ClearValues
      INVOKE     SendMessage, hEdit, WM_PASTE, 0 ,0
         jmp     returnP

idminfo:
      INVOKE     MessageBox, NULL, offset Info, offset AppName, MB_OK or MB_SYSTEMMODAL
         jmp     returnP

idmabout:
         mov     eax, offset InfoAbDlg
         mov     ebx, IDD_ABOUT
         jmp     DialogBox

DialogBox:                         ; Modal dialog box
      INVOKE     DialogBoxParam, hInst, ebx, hwnd, eax, 0
         jmp     returnP

wmbs:                              ; Backspace
      INVOKE     SendMessage, hEdit, WM_GETTEXT, 35, ADDR Buff
      INVOKE     lstrlen, ADDR Buff
      .if eax == 0
            jmp     returnP
      .endif
      .if eax == 2 && byte ptr Buff == '-'
            jmp     wmclr
      .endif
INVOKE     SendMessage, hEdit, WM_KEYDOWN, 8, 000e0001h
INVOKE     SendMessage, hEdit, WM_CHAR, 8, 000e0001h
INVOKE     SendMessage, hEdit, WM_KEYUP, 8, 0c00e0001h
      INVOKE     SendMessage, hEdit, WM_GETTEXT, 35, ADDR Buff
;INVOKE     SetWindowText, hWnd, addr Buff
      INVOKE     lstrcpy, ADDR ConvO, ADDR Buff

;      INVOKE     lstrcpyn, ADDR ConvO, ADDR Buff, eax
;      INVOKE     SendMessage, hEdit, WM_SETTEXT, NULL, ADDR ConvO
;      INVOKE     SendMessage, hEdit, EM_SETSEL, 33, 33
;      INVOKE     SetFocus, hWnd
      INVOKE     lstrcpy, ADDR Buff, ADDR ConvO
        call     AsciiToBase
      INVOKE     lstrcpy, ADDR Buff, ADDR ConvO
        call     AsciiToFloat
         mov     edx, offset RNum10
        call     FloatToAscii
        call     Display
INVOKE     SetFocus, hEdit
INVOKE     ShowCaret, hEdit
         jmp     returnP

wmce:                              ; Clear error
         mov     ConvO, 0h
      INVOKE     SendMessage, hEdit, WM_SETTEXT, NULL, offset ConvO
      INVOKE     SetFocus, hWnd
         jmp     returnP

wmclr:                             ; Clears all Fields
        call     ClearValues
         jmp     returnP

;******************************************************************************
defwndproc:
      INVOKE     DefWindowProc, hwnd, wmsg, wparam, lparam
         jmp     finish

wmdestroy:
      INVOKE     DeleteObject, hBrush
      INVOKE     DeleteObject, hFont
      INVOKE     DeleteObject, hDspF
      INVOKE     DeleteObject, hFontDL
      INVOKE     DestroyWindow, hWnd
      INVOKE     PostQuitMessage, NULL
         jmp     returnP

returnP: xor     eax,eax

finish:  RET

WndProc  ENDP

;=========================================================================|
;                        Clear Values.                                    |
;=========================================================================|
ClearValues proc
         mov     ConvO, 0
         mov     ConvI, 0
         mov     Buff, 0
         mov     LBuff, 0
         mov     RBuff, 0
         mov     PLBuff, 0
         mov     PRBuff, 0
         and     HPress, 0
         and     NPress, 0
         and     RPress, 0
         and     BPress, 0         ; 1=add, 2=sub, 3=mul, 4=div
         and     DP, 0
      INVOKE     SendMessage, hEdit, WM_SETTEXT, NULL, offset ConvO
      INVOKE     SetFocus, hWnd
      INVOKE     SendMessage, hOpr, WM_SETTEXT, NULL, ADDR Clear
         mov     Len, 0
      INVOKE     CLRMW, offset R, 32
        call     Display 
         and     First, 0
        fldz
        fstp     RNum10
        fldz
        fstp     RWrk10
         ret
ClearValues endp

;=========================================================================|
;                        About Box Dialog Procedure.                      |
;=========================================================================|
InfoAbDlg proc    hdlg:DWORD, wmsg:DWORD, wparam:DWORD, lparam:DWORD
      .if wmsg != WM_COMMAND
            jmp     AboutDone
      .endif
         mov     eax, wparam
      .if eax == 1 || eax == 2        ; CANCEL or OK
         INVOKE     EndDialog, hdlg, wparam
            mov     eax, TRUE         ; Return
            jmp     AboutRet          ; with TRUE
      .endif
AboutDone:
         mov     eax, FALSE           ; Return with FALSE
AboutRet:
         ret
InfoAbDlg endp

;=========================================================================|
;                        Processes keyboard input.                        |
;=========================================================================|
EditProc PROC hwnd:DWORD, wmsg:DWORD, wparam:DWORD, lparam:DWORD

         mov     Key, 0
      .if wmsg == WM_KEYDOWN
         INVOKE     SendMessage, hEdit, EM_GETSEL, addr w1, addr w2
            mov     eax, w1
         .if w2 > eax && wparam != 17  ; ctl key
              call     ClearValues
         .endif
      .endif
      .if wmsg == WM_PASTE
           call     ClearValues
            mov     Key, 288
            jmp     pass
      .endif

      .if wmsg == WM_CHAR
;DSPValue hWnd, wparam, 1, 't'
.if wparam != 8 && wparam != 2ah && wparam != 2bh && wparam != 2dh && wparam != 2eh && wparam != 2fh &&\
    wparam != 3dh && wparam != 0dh
   .if Base == 10 && wparam < '0' || Base == 10 && wparam > '9' ||\
       Base == 8 && wparam < '0' || Base == 8 && wparam > '7' ||\
       Base == 2 && wparam < '0' || Base == 2 && wparam > '1'
         mov     eax, 1
         ret
   .endif
.endif
.if wparam >= 'a' && wparam <= 'f'
      sub     wparam, 20h
.endif
.if wparam == 3dh || wparam == 0dh || wparam == 2dh || wparam == 2fh
      mov     eax, 1
      ret
.endif
         .if wparam == 2bh
               mov     wmsg, WM_KEYUP
               mov     wparam, 6bh
         .endif
         .if wparam == 2ah
               mov     wmsg, WM_KEYUP
               mov     wparam, 6ah
         .endif
      .endif

      .if wmsg == WM_KEYUP
.if wparam == 25h || wparam == 27h || wparam == 8 ;|| wparam == 2eh  ; LA - RA - BS - DEL
      mov     eax, 1
      ret
.endif
.if wparam != 6bh && wparam != 6dh && wparam != 0bdh && wparam != 6ah && wparam != 6fh && wparam != 0bfh &&\
    wparam != 0dh && wparam != 0bbh && wparam != 6eh && wparam != 0beh && wparam != 2eh
   .if Base == 10 && wparam < '0' || Base == 10 && wparam > '9' ||\
       Base == 8 && wparam < '0' || Base == 8 && wparam > '7' ||\
       Base == 2 && wparam < '0' || Base == 2 && wparam > '1'
      INVOKE     SetFocus, hEdit
      INVOKE     ShowCaret, hEdit
         mov     eax, 1
         ret
   .endif
.endif
;.if wparam != 8
         INVOKE     SetFocus, hWnd
;.endif

         INVOKE     SendMessage, hEdit, WM_GETTEXT, 35, ADDR Buff
         INVOKE     lstrlen, ADDR Buff
            mov     cl, byte ptr Buff[eax-1]
         .if cl >= '0' && cl <= '9' || cl >= 'a' && cl <= 'f' || cl >= 'A' && cl <= 'F' || cl == '.'
         .else
            INVOKE     lstrcpyn, addr Buff, addr Buff, eax
            INVOKE     SendMessage, hEdit, WM_SETTEXT, NULL, ADDR Buff
INVOKE     SetFocus, hEdit
INVOKE     SendMessage, hEdit, EM_SETSEL, 35, 35
            INVOKE     lstrlen, addr Buff
         .endif
         .if eax > 16 && BPress == 3
            INVOKE     MessageBeep, MB_OK
               mov     Buff + 15, 0
            INVOKE     SendMessage, hEdit, WM_SETTEXT, NULL, ADDR Buff
         .endif
         .if eax > 19 && BPress == 4 || eax > 19 && Float == 1
            INVOKE     MessageBeep, MB_OK
               mov     Buff + 18, 0
            INVOKE     SendMessage, hEdit, WM_SETTEXT, NULL, ADDR Buff
         .endif

         .if wparam > 2fh && wparam < 3ah
             MOVmd     Key, wparam
               sub     Key, 48
               add     Key, 200
               jmp     pass
         .endif
         .if wparam > 5fh && wparam < 6ah
             MOVmd     Key, wparam
               sub     Key, 96
               add     Key, 200
               jmp     pass
         .endif
         .if wparam > 40h && wparam < 47h
             MOVmd     Key, wparam
               sub     Key, 55
               add     Key, 200
               jmp     pass
         .endif

         .if wparam == 6eh || wparam == 0beh || wparam == 2eh
               mov     Key, 216    ; .
         .elseif wparam == 6bh ;|| wparam == 0bbh
               mov     Key, 218    ; +
         .elseif wparam == 6dh || wparam == 0bdh
               mov     Key, 219    ; -
         .elseif wparam == 6ah ;|| wparam == 0bah
               mov     Key, 220    ; *
         .elseif wparam == 6fh || wparam == 0bfh
               mov     Key, 221    ; /
         .elseif wparam == 0dh || wparam == 0bbh
               mov     Key, 222    ; =
         .else
         .endif
      .endif

pass:
      INVOKE     CallWindowProc, SubEdit, hwnd, wmsg, wparam, lparam
      .if wmsg == WM_CUT
           call     ClearValues
      .endif
      .if Key > 0
           call     ToolbarProc
      .endif
         RET
EditProc   ENDP

;=========================================================================|
;                       Processes calculator input.                       |
;=========================================================================|
ToolbarProc   PROC  uses ebx ecx edx esi edi  hwnd:DWORD, wmsg:DWORD, wparam:DWORD, lparam:DWORD
LOCAL    KeyBrd:DWORD

      .if wmsg == WM_COMMAND || Key > 0
         INVOKE     SendMessage, hOpr, WM_SETTEXT, NULL, ADDR Clear
;inc     Test44
;DSPValue hWnd, Test44, 1, 't'
            and     KeyBrd, 0
         .if Key > 0
               mov     KeyBrd, 1
             MOVmd     wparam, Key
               mov     Key, 0
;;;            INVOKE     SetFocus, hWnd
         .endif
         INVOKE     SendMessage, hEdit, WM_GETTEXT, 35, offset ConvO
         INVOKE     SendMessage, hEdit, WM_GETTEXT, 35, offset Buff
;INVOKE     SetWindowText, hWnd, addr Buff
         .if Buff == '*'
               jmp     GetOut
         .endif
            mov     eax, wparam
            mov     N, 0

         .if eax == 288
               mov     ConvI, 0
            INVOKE     lstrlen, addr Buff
               mov     esi, eax
               xor     edi, edi
               mov     eax, '0'
               mov     ecx, '0'
               mov     edx, '0'
            .if Base == 10 || Base == 16
                  mov     ebx, '9'
               .if Base == 16
                     mov     ecx, 'A'
                     mov     edx, 'F'
               .endif
            .elseif Base == 2
                  mov     ebx, '1'
            .elseif Base == 8
                  mov     ebx, '7'
            .endif
            .while (esi)
               .if byte ptr Buff[edi] > 90
                     sub     byte ptr Buff[edi], 32
                     sub     byte ptr ConvO[edi], 32
               .endif
               .if byte ptr Buff[edi] >= al && byte ptr Buff[edi] <= bl\
                || byte ptr Buff[edi] >= cl && byte ptr Buff[edi] <= dl
               .else
                    call     ClearValues
                  INVOKE     MessageBox, NULL, addr szPaste, addr AppName, MB_OK or\
                             MB_ICONWARNING or MB_TASKMODAL
                     jmp     GetOut
               .endif
                  inc     edi
                  dec     esi
            .endw
               jmp     DecP
         .endif

         .if Base == 10 || Base == 8  ; Dec or Oct
              mov      N, 1
         .endif
;         .if ((eax > 199 && eax < 210 && N == 1 || eax > 199 && eax < 216 && Base == 16)\
;           || (eax > 199 && eax < 202 && Base == 2 || eax == 216))
         .if eax > 199 && eax < 216 && Base == 16 || eax > 199 && eax < 210 && Base == 10 ||\
             eax > 199 && eax < 208 && Base == 8 || eax > 199 && eax < 202 && Base == 2 || eax == 216
               mov     eax, wparam
               sub     eax, 200
            .if eax == 16
               .if DP == 0  
                  mov     ConvI, '.'
                  mov     ConvI+1, 0
               .else
                  mov     ConvI, 0
               .endif
                  jmp     DecP
            .endif
               lea     ebx, offset FmtA
            .if Base ==16
                  lea     ebx, offset FmtH
            .endif
            INVOKE     wsprintf, ADDR ConvI, ebx, eax

DecP:
            .if ConvO == '0' && ConvO + 1 == 0
                  mov     ConvO, 0
            .endif
INVOKE     lstrlen, addr ConvO
.if !KeyBrd || !eax
            INVOKE     lstrcat, offset ConvO, offset ConvI
.endif
               mov     KeyBrd, 0
            INVOKE     SendMessage, hEdit, WM_SETTEXT, NULL, offset ConvO
            INVOKE     lstrlen, ADDR ConvO
               mov     ebx, 34
            .if Base == 16
                  mov     ebx, 28
            .endif
            .if eax > ebx
               INVOKE     MessageBeep, MB_OK
                  mov     ConvO[ebx], 0
               INVOKE     SendMessage, hEdit, WM_SETTEXT, NULL, ADDR ConvO
            .endif
            .if eax > 16 && BPress == 3
               INVOKE     MessageBeep, MB_OK
                  mov     ConvO + 16, 0
               INVOKE     SendMessage, hEdit, WM_SETTEXT, NULL, ADDR ConvO
            .endif
            .if eax > 19 && BPress == 4 || eax > 19 && Float == 1
               INVOKE     MessageBeep, MB_OK
                  mov     ConvO + 19, 0
               INVOKE     SendMessage, hEdit, WM_SETTEXT, NULL, ADDR ConvO
            .endif
            INVOKE     SendMessage, hEdit, EM_SETSEL, 34, 34
            INVOKE     lstrcpyn, ADDR Buff, ADDR ConvO, 34
              call     AsciiToBase
            INVOKE     lstrcpyn, ADDR Buff, ADDR ConvO, 34
              call     AsciiToFloat
               mov     edx, offset RNum10
              call     FloatToAscii
              call     Display
INVOKE     SetFocus, hEdit
INVOKE     ShowCaret, hEdit
               mov     eax, wparam
         .endif

;--------[ Memory clear ]-------------------------------------------------
         .if eax == IDB_BUTMC
               and     StoreFlag, 0
              fldz
              fstp     RMem10
            INVOKE     CLRMW, offset MEM, 12
            INVOKE     SendMessage, hMem, WM_SETTEXT, NULL, ADDR Clear
         .endif
  
;--------[ Memory recall ]------------------------------------------------
         .if eax == IDB_BUTMR
            .if BPress == 0
                  fld     RMem10
                 fstp     RNum10
                  fld     RMem10
                 fstp     RWrk10
            .else
                  fld     RNum10
                 fstp     RWrk10
                  fld     RMem10
                 fstp     RNum10
            .endif
               mov     edx, offset RNum10

              call     FloatToAscii
MOVmd     MEM+40, SubZero
            INVOKE     CopyMW, offset R, offset MEM, 12
              call     BaseToAscii
            INVOKE     SendMessage, hEdit, WM_SETTEXT, NULL, ADDR ConvO
            INVOKE     SendMessage, hEdit, EM_SETSEL, 33, 33
              call     Display
         .endif
  
;--------[ Memory store ]-------------------------------------------------
         .if eax == IDB_BUTMS
StoreMem:
               mov     StoreFlag, 1
               fld     RNum10
              fstp     RMem10
            INVOKE     CopyMW, offset MEM, offset R, 12
            INVOKE     SendMessage, hMem, WM_SETTEXT, NULL, ADDR M
              call     StoreCLR
               jmp     GetOut
         .endif
  
;--------[ Memory add ]---------------------------------------------------
         .if eax == IDB_BUTMP
               cmp     StoreFlag, 0
                je     StoreMem
               fld     RNum10
               fld     RMem10
              fadd     ST(0), ST(1)
              fstp     RMem10
               mov     edx, offset RMem10
              call     FloatToAscii

            INVOKE     CopyMW, offset PT, offset MEM, 12
               mov     BPress, 1
              call     Prep
              call     AddEM
               mov     BPress, 0
            INVOKE     CopyMW, offset MEM, offset R, 12
            INVOKE     SendMessage, hMem, WM_SETTEXT, NULL, ADDR M
              call     StoreCLR
         .endif
  
;--------[ Memory subtract ]----------------------------------------------
         .if eax == IDB_BUTMM
               cmp     StoreFlag, 0
                je     StoreMem
               fld     RNum10
               fld     RMem10
              fsub     ST(0), ST(1)
              fstp     RMem10
               mov     edx, offset RMem10
              call     FloatToAscii
 
            INVOKE     CopyMW, offset PT, offset MEM, 12
               mov     BPress, 2   
              call     Prep
              call     SubEM
               and     BPress, 0
            INVOKE     CopyMW, offset MEM, offset R, 12
            INVOKE     SendMessage, hMem, WM_SETTEXT, NULL, ADDR M
              call     StoreCLR
         .endif

;--------[ Load pi ]------------------------------------------------------
         .if eax == IDB_BUTPI
             fldpi
              fstp     RNum10
               mov     edx, offset RNum10
              call     FloatToAscii 
            INVOKE     SendMessage, hEdit, WM_SETTEXT, NULL, ADDR Pi
            INVOKE     SendMessage, hEdit, EM_SETSEL, 33, 33
            INVOKE     lstrcpy, ADDR Buff, ADDR Pi
              call     AsciiToBase
              call     Display
         .endif

;--------[ Trig functions ]-----------------------------------------------
         .if eax == IDB_BUTSIN || eax == IDB_BUTCOS || eax == IDB_BUTTAN ||\
             eax == IDB_BUTSEC || eax == IDB_BUTCSC || eax == IDB_BUTCOT
             finit
               fld     RNum10
            .if T == 1
                  fld     RDeg10
                 fmul     ST(0), ST(1)
               .if eax == IDB_BUTTAN && ArcOn == 1
                     fld     RNum10
               .endif
            .endif   
            .if eax == IDB_BUTSIN
               .if ArcOn == 0
                     fsin
               .else
                     fld     st(0)       ; Duplicate X on tos.
                    fmul                 ; Compute X**2.
                     fld     st(0)       ; Duplicate X**2 on tos.
                    fld1                 ; Compute 1-X**2.
                   fsubr
                    fdiv                 ; Compute X**2/(1-X**2).
                   fsqrt                 ; Compute sqrt(x**2/(1-X**2)).
                    fld1                 ; To compute full arctangent.
                  fpatan                 ; Compute atan of the above.
               .endif
            .elseif eax == IDB_BUTCOS
               .if ArcOn == 0
                    fcos
               .else
                     fld     st(0)       ; Duplicate X on tos.
                    fmul                 ; Compute X**2.
                     fld     st(0)       ; Duplicate X**2 on tos.
                    fld1                 ; Compute 1-X**2.
                   fsubr
                   fdivr                 ; Compute (1-x**2)/X**2.
                   fsqrt                 ; Compute sqrt((1-X**2)/X**2).
                    fld1                 ; To compute full arctangent.
                  fpatan                 ; Compute atan of the above.
               .endif
            .elseif eax == IDB_BUTTAN && ArcOn == 0
                fptan
                 fmul     ST(0), ST(1)
            .elseif eax == IDB_BUTTAN && ArcOn == 1
                 fld1                    ; To compute full arctangent.
               fpatan                    ; Compute atan of the above.
               .if T == 1
                     fld     RRad10
                    fmul     ST(0), ST(1)
               .endif
            .elseif eax == IDB_BUTSEC
               .if ArcOn == 0
                    fcos
                    fld1
                   fdivr
               .else
                     fld     st(0)       ; Duplicate
                    fmul                 ; Compute x*x
                    fld1                 ; Load 1
                    fsub                 ; Compute x*x-1
                   fsqrt                 ; Compute sqrt(x*x-1)
                    fld1                 ; Load 1
                  fpatan                 ; Compute atan of above.
               .endif 
            .elseif eax == IDB_BUTCSC
               .if ArcOn == 0
                    fsin
                    fld1
                   fdivr
               .else
                     fld     st(0)       ; Duplicate
                    fmul                 ; Compute x*x
                    fld1                 ; Load 1
                    fsub                 ; Compute x*x-1
                    fld1                 ; Load 1
                   fdivr                 ; Compute 1/(x*x-1)
                   fsqrt                 ; Compute sqrt(1/(x*x-1))
                    fld1                 ; Load 1
                  fpatan                 ; Compute atan of above.
               .endif  
            .elseif eax == IDB_BUTCOT
               .if ArcOn == 0
                 fsincos
                   fdivr
               .else
                    fld1                 ; fpatan computes
                    fxch                 ; atan(st(1)/st(0)).
                  fpatan                 ; atan(st(0)/st(1)).
               .endif
            .endif
              fstp     RNum10
            .if ArcOn == 0 || ArcOn == 1 && eax == IDB_BUTTAN
                  or      NoFix, 1
            .endif
               mov     edx,offset RNum10
              call     FloatToAscii
               and     NoFix, 0
               jmp     FromSQ
         .endif

;--------[ Log 10 function ]----------------------------------------------
         .if eax == IDB_BUTLOG && Buff != 0
             finit
              call     AsciiToFloat
               fld     RNum10
              fld1
              fxch
             fyl2x                         ; st(1) * log2(st(0)) 'alpha l not num 1'
            fldl2t
              fdiv
              fstp     RNum10
               mov     edx,offset RNum10
              call     FloatToAscii
               jmp     FromSQ
         .endif

;--------[ Exponent functions ]-------------------------------------------
         .if eax == IDB_BUT2X || eax == IDB_BUT10X || eax == IDB_BUTEX && Buff != 0
             finit
              call     AsciiToFloat
               fld     RNum10
            .if eax == IDB_BUT2X
                  call     TwoX
            .elseif eax == IDB_BUT10X
                  call     TenX
            .elseif eax == IDB_BUTEX
                  call     ExpX
            .endif
               mov     edx,offset RNum10
              call     FloatToAscii
               jmp     FromSQ
         .endif

;--------[ Square root function ]-----------------------------------------
         .if eax == IDB_BUTSQ && Buff != 0
             finit
              call     AsciiToFloat
               fld     RNum10
             fsqrt
              fstp     RNum10
               mov     edx,offset RNum10
              call     FloatToAscii
               jmp     FromSQ
         .endif

;--------[ Hypotenuse function ]------------------------------------------
         .if eax == IDB_BUTHYP
              call     StoreCLR
               or      HPress, 1
               jmp     GetOut
         .endif
 
;--------[ Pecentage function ]-------------------------------------------
         .if eax == IDB_BUTPCT
             push      BPress
              and      BPress, 0
               or      BPress, 3
              call     Prep
            INVOKE     CopyMW, offset RH, offset PT, 12
            INVOKE     lstrcpy, ADDR PLBuff, ADDR HLBuff
            INVOKE     lstrcpy, ADDR PRBuff, ADDR HRBuff
              call     MulEM
              call     BaseToAscii
               and     BPress, 0
              call     StoreCLR
               mov     dword ptr Buff, 0031302eh
              call     AsciiToBase
              call     BaseToAscii
              call     Prep
                or     BPress, 3
              call     MulEM
              call     BaseToAscii
            INVOKE     SendMessage, hEdit, WM_SETTEXT, NULL, ADDR ConvO
            INVOKE     SendMessage, hEdit, EM_SETSEL, 33, 33

               pop     BPress
            .if BPress > 0
               INVOKE     CopyMW, offset PT, offset RH, 12
               INVOKE     lstrcpy, ADDR HLBuff, ADDR PLBuff
               INVOKE     lstrcpy, ADDR HRBuff, ADDR PRBuff
                  jmp     GetOut
            .endif
               jmp     GetOut
         .endif

;--------[ X to the 2 power function ]------------------------------------
         .if eax == IDB_BUTPOW && Buff != 0
            .if Float == 0
               INVOKE     lstrcpy, offset HLBuff, offset LBuff
               INVOKE     lstrcpy, offset HRBuff, offset RBuff
               INVOKE     CopyMW, offset PT, offset R, 12
               .if PT+36 > 0 || R+36 > 0
                     mov     BPress, 3
                    call     ShiftDec
                     jmp     EndIt
               .endif
                 call     Prep
                 call     MulMW
               INVOKE     CopyMW, offset R, offset R3, 4
                 call     BaseToAscii
                  jmp     EndIt
            .endif
             finit
              call     AsciiToFloat
               fld     RNum10
               fld     ST(0)
             fmulp     ST(1), ST(0)
              fstp     RNum10
               mov     edx,offset RNum10
              call     FloatToAscii
EndIt:
               jmp     FromSQ
         .endif

;--------[ X to the Nth power function ]----------------------------------
         .if eax == IDB_BUTXN
              call     StoreCLR
               or      NPress, 1
               jmp     GetOut
         .endif

;--------[reciprocal of 1 function ]--------------------------------------
         .if eax == IDB_BUTREC && Buff != 0
               mov     ConvH, 31h
               mov     HLBuff, 31h
               mov     HRBuff, 0
               mov     HLen, 0
            INVOKE     CLRMW, offset PT, 12
               mov     PT+12, 1
               mov     BPress, 4
               or      RPress, 1
              fld1
              fstp     RWrk10
               jmp     Continue
         .endif

;--------[ Plus or Minus ]--------------------------------------------------
         .if eax == IDB_BUTPM
            INVOKE     SendMessage, hEdit, WM_GETTEXT, 35, offset ConvO
            .if ConvO != 2dh
                  mov     word ptr ConvI, 002dh
               INVOKE     lstrcat, ADDR ConvI, ADDR ConvO
            .else
               INVOKE     lstrcpy, ADDR ConvI, ADDR ConvO + 1
            .endif
            .if ConvI+1 != 0
               INVOKE     lstrcpy, ADDR Buff, ADDR ConvI
                 call     AsciiToBase
               INVOKE     lstrcpy, ADDR Buff, ADDR ConvI
                 call     AsciiToFloat
            .endif
               INVOKE     SendMessage, hEdit, WM_SETTEXT, NULL, ADDR ConvI
                 call     Display
         .endif

;--------[ Addition function ]---------------------------------------------
         .if eax == IDB_BUTADD
            INVOKE     SendMessage, hOpr, WM_SETTEXT, NULL, ADDR PO
              call     StoreCLR
               mov     BPress, 1
               jmp     GetOut
         .endif

;--------[ Subtraction function ]------------------------------------------
         .if eax == IDB_BUTSUB
            INVOKE     SendMessage, hOpr, WM_SETTEXT, NULL, ADDR SO
              call     StoreCLR
               mov     BPress, 2
               jmp     GetOut
         .endif

;--------[ Multiply function ]---------------------------------------------
         .if eax == IDB_BUTMUL
            INVOKE     SendMessage, hOpr, WM_SETTEXT, NULL, ADDR MO
              call     StoreCLR
               mov     BPress, 3
               jmp     GetOut
         .endif

;--------[ Divide function ]-----------------------------------------------
         .if eax == IDB_BUTDIV
            INVOKE     SendMessage, hOpr, WM_SETTEXT, NULL, ADDR DO
              call     StoreCLR
               mov     BPress, 4
               jmp     GetOut
         .endif

;--------[ Equate function ]-----------------------------------------------
         .if eax == IDB_BUTEQ
            INVOKE     SendMessage, hOpr, WM_SETTEXT, NULL, ADDR EO
Continue:
            .if Float == 0          ; not floating point
                 call     Prep
               .if BPress == 1
                    call     AddEM  
                     jmp     FromSQ
               .elseif BPress == 2
                    call     SubEM
                     jmp     FromSQ
               .elseif BPress == 3
                    call     MulEM
                     jmp     FromSQ
               .elseif BPress == 4
                    call     DivEM
                     jmp     FromSQ
               .elseif NPress == 1
                  .if PT+36 == 0 && R+36 == 0 ; no decimals
                       call     PowerN
                        jmp     FromSQ
                  .else
                        jmp     FP
                  .endif
               .elseif HPress == 1
                     jmp     FP
               .else
                     jmp     GetOut
               .endif
            .endif

FP:
             finit
               fld     RNum10
               fld     RWrk10
            .if BPress == 1
                 fadd     ST(0), ST(1)
            .elseif BPress == 2
                 fsub     ST(0), ST(1)
            .elseif BPress == 3
                 fmul     ST(0), ST(1)
            .elseif BPress == 4 && R+12 > 0 || BPress == 4 && R+28 > 0
                 fdiv     ST(0), ST(1)
            .elseif NPress == 1
                 fld1
                 fxch
                fyl2x                         ; st(1) * log2(st(0)) 'alpha l not num 1'
                 fmul
                 call     TwoX
            .elseif HPress == 1
                  fld     RWrk10
                  fld     ST(0)                ; duplicate
                fmulP     ST(1), ST(0)
                 fstp     RWrk10
                  fld     RNum10
                  fld     ST(0)                ; duplicate
                fmulp     ST(1), ST(0)
                  fld     RWrk10
                 fadd     ST(0), ST(1)
                fsqrt
            .endif
              fstp     RNum10
               fld     RNum10
              fstp     RWrk10
StoreR:
               mov     edx, offset RNum10
              call     FloatToAscii

FromSQ:
            INVOKE     SendMessage, hEdit, WM_SETTEXT, NULL, ADDR ConvO
            INVOKE     SendMessage, hEdit, EM_SETSEL, 33, 33
               and     First, 0
               and     HPress, 0
               and     NPress, 0
               and     RPress, 0
               and     BPress, 0
               and     DP, 0
            INVOKE     SendMessage, hEdit, WM_GETTEXT, 34, offset Buff
            .if Buff == '*'
                  mov     Buff, 0
            .endif
              call     AsciiToBase
              call     BaseToAscii
              call     Display
            INVOKE     SendMessage, hEdit, WM_GETTEXT, 34, offset Buff ; for floating point ???
              call     AsciiToBase
              fldz
              fstp     RWrk10
              fldz
              fstp     RNum10
            INVOKE     SendMessage, hEdit, WM_GETTEXT, 34, offset Buff ; for floating point ???
              call     AsciiToFloat
               and     Min, 0
INVOKE     SetFocus, hEdit
         .endif
      .endif
GetOut:
      INVOKE        CallWindowProc, SubTool, hwnd, wmsg, wparam, lparam
         RET
ToolbarProc   ENDP

;=========================================================================|
;                       Setup for addition routine.                       |
;=========================================================================|
AddEM   PROC  uses ebx
      .if Branch
            jmp     DoAdd
      .endif 
         mov     eax, PT+44
         mov     ebx, R+44
      .if eax != ebx                 ; signs not equal
          MOVmd     R5+32, PT+44 
            and     BPress, 0
            or      BPress, 2
            or      Branch, 1
           call     SubEM
            jmp     Exit
      .endif
DoAdd:
        call     AddMW
        call     BaseToAscii
         mov     eax, R+36
      .if eax > HLen
            mov     HLen, eax
      .endif
      INVOKE     lstrlen, offset RBuff
      .if eax > HLen && DecPos > 0
           call     Round
      .endif
         and     Branch, 0
Exit:
         RET
AddEM   ENDP

;=========================================================================|
;                      Setup for subtraction routine.                     |
;=========================================================================|
SubEM   PROC  uses ebx
      .if Branch
            jmp     DoSub
      .endif
         mov     eax, PT+44
         mov     ebx, R+44
      .if eax != ebx                 ; signs not equal
          MOVmd     R+44, R5+36
            or      Branch, 1
           call     AddEM
            jmp     Exit
      .endif
      .if R5+32 == 1
            and     R5+32, 0
      .else
            or      R5+32, 1
      .endif
DoSub:
         mov     eax, R+36           ; R+36 = length of dec num's cur
      .if eax > HLen                 ; HLen = length of dec num's prev
            mov     HLen, eax
      .endif
      INVOKE     lstrcmpi, offset HRBuff, offset RBuff
      .if eax == -1                  ; A < B
           call     Round
      .endif
       MOVmd     R+44, R5+32
        call     SubMW
        call     BaseToAscii
      INVOKE     lstrlen, offset RBuff
      .if HLen > eax && DecPos > 0
         INVOKE     lstrcpy, ADDR ConvO, ADDR LBuff
         INVOKE     lstrcat, ADDR ConvO, ADDR Period
         INVOKE     lstrcat, ADDR ConvO, ADDR Zero
         INVOKE     lstrcat, ADDR ConvO, ADDR RBuff
         INVOKE     lstrlen, offset LBuff+1
         INVOKE     lstrcpy, ADDR RBuff, ADDR ConvO[eax]    ; non decimal number
      .endif
         mov     BPress, 0
         and     Branch, 0
Exit:
         RET
SubEM   ENDP

;=========================================================================|
;                       Setup for  multiply routine.                      |
;=========================================================================|
MulEM   PROC  uses ebx
      .if PT+36 > 0 || R+36 > 0 ; Decimal numbers
           call     ShiftDec
            jmp     Exit
      .endif 
        call     MulMW
      INVOKE     CopyMW, offset R, offset R3, 4
         mov     eax, PT+44
         mov     ebx, R+44
         and     R+44, 0
      .if eax != ebx            ; Minus
            or      R+44, 1
      .endif
        call     BaseToAscii
Exit:
         RET
MulEM   ENDP

;=========================================================================|
;                         Setup for  divide routine.                      |
;=========================================================================|
DivEM   PROC  uses ebx
      .if R > 0 || R+4 > 0 || R+4 > 0 || R+8 > 0 || R+24 > 0
           call     FPDivMW
            jmp     Exit
      .endif
      .if PT+36 > 0 || R+36 > 0
           call     ShiftDec
            jmp     Exit
      .endif
        call     DivMW
      INVOKE     CopyMW, offset R, offset R2, 4
         mov     eax, PT+44
         mov     ebx, R+44
         and     R+44, 0
      .if eax != ebx            ; Minus
            or      R+44, 1
      .endif
        call     BaseToAscii
Exit:
         RET
DivEM   ENDP

;=========================================================================|
;           Rounding or borrowing for decimal add and subtract.           |
;=========================================================================|
Round   PROC
         cmp     BPress, 2
         je      Subem
      INVOKE     lstrlen, ADDR LBuff
         add     eax, 2
      INVOKE     lstrcpyn, ADDR Buff, ADDR ConvI, eax
      INVOKE     lstrcat, ADDR Buff, ADDR RBuff + 1
        call     AsciiToBase
      .if HRBuff > '0' 
            add     R+12, 1
      .endif
        call     BaseToAscii
         jmp     Done
Subem:
      INVOKE     lstrcpy, ADDR Buff, ADDR HLBuff
      INVOKE     lstrcat, ADDR Buff, ADDR Period
      INVOKE     lstrcat, ADDR Buff, ADDR One
      INVOKE     lstrcat, ADDR Buff, ADDR HRBuff
        call     AsciiToBase
         sub     R+12, 1

      INVOKE     lstrcpy, ADDR Buff, ADDR LBuff
      INVOKE     lstrcat, ADDR Buff, ADDR Period
      INVOKE     lstrcat, ADDR Buff, ADDR Zero
      INVOKE     lstrcat, ADDR Buff, ADDR RBuff
      INVOKE     CopyMW, offset PT, offset R, 12
        call     AsciiToBase
        push     R5+32
        call     Prep
         pop     R5+32
Done:   
         RET
Round   ENDP

;=========================================================================|
;   Converts ascii string of Dec, Hex, Oct or Bin to a 128 bit num value. |
;=========================================================================|
AsciiToBase PROC  uses ebx edi
         and     DP, 0   
         and     Pos, 0
         and     cnt, 0
      INVOKE     CLRMW, offset R, 32
      INVOKE     lstrlen, ADDR Buff
      .if sw1 == 19 && eax > 19 && BPress == 3  ; Limit Multiplicand & Multiplier to 19
            mov     edx, offset Buff
            add     edx, 18
         .if byte ptr [edx]+1 >= 35h
               inc     byte ptr [edx]+0 ; + 1
         .endif
            mov     byte ptr [edx]+1, 0
            sub     eax, 19
            mov     Work, eax
      .endif
      INVOKE     lstrlen, ADDR Buff
         mov     ecx, offset Buff
         xor     edx, edx
      .while (eax)
         .if byte ptr [ecx] > 60h
               sub     byte ptr [ecx], 57h
               and     Pos, 0
         .elseif byte ptr [ecx] > 40h
               sub     byte ptr [ecx], 37h
               and     Pos, 0
         .elseif byte ptr [ecx] == 2eh
                or     Pos, 1
                or     cnt, 1
                or     DP, 1
;******* Reduce decimal numbers to 19  ;16
              push     eax
              push     ecx
              push     edx
            INVOKE     lstrlen, ADDR Buff
               pop     edx
               mov     ebx, offset Buff
               add     ebx, edx
               sub     eax, edx
            .if eax > 19
               .if byte ptr [ebx]+20 >= 35h
                     inc     byte ptr [ebx]+19 ; + 1
               .endif
                  mov     byte ptr [ebx]+20, 0 ; Terminate string
            .endif
               pop     ecx
               pop     eax
;*******
         .elseif byte ptr [ecx] == 2dh
               or      R+44, 1                 ; Minus
         .else
               xor     byte ptr [ecx], 30h
            .if  byte ptr [ecx] == 0h && Pos == 1
                  add     R+40, 1              ; Number of leading zeros after decimal
            .else
                  and     Pos, 0
            .endif   
         .endif
            inc     ecx
            inc     edx 
         .if cnt == 0
               mov     R+32, edx               ; Number of whole numbers
         .endif
            cmp     edx, 32 ;64                    ; 32 !!!!!!!!!!!!!!!!!!
            jnb     done
            dec     eax
      .endw

done:
      .if edx == 0 || edx == 1 && R+44 == 1 
            inc     edx
      .endif
       MOVmd     HBase, Base
         mov     edi, offset Buff           ; edi points to string to copy
         mov     R3+12, 1
         mov     R4+12, 1
         add     edi, edx
         dec     edi
         and     cnt, 0
      .if R+44 == 1
            dec     edx
            sub     R+32, 1
      .endif

Conv:
      .if byte ptr[edi] == 2eh
          MOVmd     D+32, R+32              ; Number of whole numbers
          MOVmd     D+36, cnt               ; Number of decimal numbers
          MOVmd     D+40, R+40              ; Number of leading zeros after decimal
          MOVmd     D+44, R+44              ; Minus
         INVOKE     CopyMW, offset D+16, offset R, 4
         INVOKE     CLRMW, offset R, 32  
         INVOKE     CopyMW, offset R+16, offset D+16, 8
            mov     R3+12, 1
            mov     R4+12, 1
            jmp     PastDec
      .endif
         add     cnt, 1
         mov     al, byte ptr[edi]          ; Move byte edi points to into al
         and     eax, 000000ffh

      INVOKE     CLRMW, offset B, 4  
         mov     B+12, eax
      INVOKE     CopyMW, offset A, offset R4, 4
        call     MulMW

      INVOKE     CopyMW, offset A, offset R, 4
      INVOKE     CopyMW, offset B, offset R3, 4
         or      PassDec, 1
        call     AddMW
         and     PassDec, 0

      INVOKE     CopyMW, offset A, offset R4, 4
      INVOKE     CLRMW, offset B, 4  
       MOVmd     B+12, Base
        call     MulMW
      INVOKE     CopyMW, offset R4, offset R3, 4

PastDec:
         dec     edi
         dec     edx
         jnz     Conv
         RET
AsciiToBase ENDP

;=========================================================================|
;   Converts a 128 bit num value to a Dec, Hex, Oct or Bin ascii string.  |
;=========================================================================|
BaseToAscii PROC
         mov     DecPos, 0
        push     Base
        push     esi
        push     edi

      .if sw2 != 0
          MOVmd     Base, sw2
      .endif
         mov     Pos, 0
      .if R+28 > 0
         INVOKE     CopyMW, offset A, offset R+16, 4
            mov     Pos, 1
      .else
         INVOKE     CopyMW, offset A, offset R, 4
      .endif
       MOVmd     B+12, Base
         xor     edi, edi
         xor     esi, esi

Loop1:
         or      R5+24, 1
        call     DivMW
         and     R5+24, 0
      INVOKE     CopyMW, offset A, offset R2, 4
      .if dl > 9h
            add     dl,37h         ; Convert to hex ASCII
      .else
            add     dl,30h         ; Convert to dec ASCII
      .endif
         mov     Buff[esi], dl
         inc     edi
      .if A+12 > 0 || A+8 > 0 || A+4 > 0 || A > 0
            inc     esi
            jmp     Loop1
      .endif
      .if R+28 > 0 && Pos == 1     ; Decimal portion
            inc     esi
            mov     eax, R+40
            inc     eax
           push     edi
           push     esi
         INVOKE     lstrcpyn, ADDR Buff[esi], ADDR Zeros, eax  ; Number of leading zeros after dec
            pop     esi
            pop     edi
            add     edi, R+40
            add     esi, R+40
            mov     byte ptr Buff[esi], 2eh
            mov     DecPos, esi
            inc     edi
            inc     esi
         INVOKE     CopyMW, offset A, offset R, 4
            mov     Pos, 0
            jmp     Loop1
      .endif
         xor     ecx, ecx
      .if R+44 == 1                ; Minus
            mov     byte ptr ConvI, 2dh
            inc     ecx
      .endif

Loop2:
         mov     al, byte ptr Buff[esi]
         mov     byte ptr ConvI[ecx], al
         inc     ecx
         dec     esi
         dec     edi
         jnz     Loop2
         mov     byte ptr ConvI[ecx], 0h

         mov     eax, Base
      .if eax == HBase
            mov     RBuff, 0h
         INVOKE     lstrlen, ADDR ConvI
            mov     esi, offset ConvI
            mov     edi, offset LBuff
Loop3:
         .if byte ptr[esi] == 2eh
               mov     byte ptr[edi], 0h
               mov     edi, offset RBuff
               inc     esi
               dec     eax
               jz      AllDone
         .endif    
            mov     bl, byte ptr[esi]
            mov     byte ptr[edi], bl
            inc     edi
            inc     esi
            dec     eax
            jnz     Loop3
            mov     byte ptr[edi], 0h
      .endif
.if Base == 10 && !sw3
MOVmd     SubZero, R+40
.endif

AllDone:
      .if cpy != 8
         INVOKE     lstrcpy, ADDR ConvO, ADDR ConvI
      .endif
         pop     edi
         pop     esi
         pop     Base
          RET
BaseToAscii ENDP

;=========================================================================|
;                        Clears multiple dwords.                          |
;=========================================================================|
CLRMW   PROC  uses ebx To: DWORD, Num: DWORD
      pushad
         xor     eax, eax
         mov     ebx, To
         mov     ecx, Num
Loop1:   mov     dword ptr[ebx+eax], 0
         add     eax, 4
        loop     Loop1
       popad
         RET
CLRMW   ENDP

;=========================================================================|
;                        Copies multiple dwords.                          |
;=========================================================================|
CopyMW  PROC  To: DWORD, From: DWORD, Num: DWORD
      pushad
         xor     eax, eax
         mov     edx, To
         mov     ebx, From
         mov     ecx, Num
Loop1:
        push     dword ptr[ebx+eax]
         pop     dword ptr[edx+eax]
         add     eax, 4
        loop     Loop1
       popad
         RET
CopyMW  ENDP

;=========================================================================|
;                       Compares multiple dwords.                         |
;=========================================================================|
CompMW  PROC  Left: DWORD, Right: DWORD, Num: DWORD
      pushad
         xor     eax, eax
         mov     Work, 0
         mov     ebx, Left
         mov     edx, Right
         mov     ecx, Num
Loop1:
         mov     esi, dword ptr[ebx+eax]
      .if esi > dword ptr[edx+eax]
            or      Work, 1              ; A > B 
            jmp     Done
      .endif
      .if esi < dword ptr[edx+eax]
            or      Work, 2              ; A < B
            jmp     Done
      .endif
        push     dword ptr[ebx+eax]
         pop     dword ptr[edx+eax]
         add     eax, 4
        loop     Loop1
Done:
       popad
         mov     eax, Work
         and     Work, 0
         RET
CompMW  ENDP

;=========================================================================|
;         Determines the decimal position and the number                  |
;            of leading zeros for multiply and divide.                    |
;=========================================================================|
ShiftDec PROC
        push     edi
        push     esi
        push     ebx
         mov     Sav, 0
         mov     Work, 0
      INVOKE     CLRMW, offset R5, 8
       MOVmd     R5, PT+36    ; Decimal numbers dividend or Multiplicand
       MOVmd     R5+4, R+36   ; Decimal numbers divisor or Multiplier
       ;MOVmd     R5+8, PT+40  ; Leading zeros dividend or Multiplicand ** NOT USED **
       ;MOVmd     R5+12, R+40  ; Leading zeros divisor or Multiplier    ** NOT USED **
       ;MOVmd     R5+16, PT+32 ; Whole numbers dividend or Multiplicand ** NOT USED **
       ;MOVmd     R5+20, R+32  ; Whole numbers divisor or Multiplier    ** NOT USED **
      MOVmd     R5+32, PT+44  ; Minus dividend or Multiplicand
      MOVmd     R5+36, R+44   ; Minus divisor or Multiplier
      .if RBuff == 0h
            mov     R5+4, 0
      .endif
         mov     sw1, 19
      INVOKE     CLRMW, offset R, 32
      INVOKE     lstrcpy, offset Buff, offset HLBuff
      INVOKE     lstrcat, offset Buff, offset HRBuff
        call     AsciiToBase
         mov     eax, Work                          ; Work is built in AsciiToBase
      .if R5 >= eax
            sub     R5, eax                         ; Adjust the number of decimals
      .endif
      .if BPress == 4
            mov     R3+12, 1
            mov     ecx, R5+4
         .if R5 >= ecx
               sub     R5, ecx
               jmp     NoExtend
         .else
               sub     ecx, R5
               mov     R5, 0
         .endif

Extend:
         INVOKE     CopyMW, offset A, offset R3, 4
         INVOKE     CLRMW, offset B, 4  
          MOVmd     B+12, Base
           call     MulMW
           loop     Extend
         INVOKE     CopyMW, offset A, offset R, 4   ; Dividend
         INVOKE     CopyMW, offset B, offset R3, 4  ; Extend value
           call     MulMW
         INVOKE     CopyMW, offset R, offset R3, 4  ; Product
      .endif

NoExtend:
         mov     Work, 0 
      INVOKE     CopyMW, offset PT, offset R, 12
      INVOKE     CLRMW, offset R, 32
      INVOKE     lstrcpy, offset Buff, offset LBuff
      INVOKE     lstrcat, offset Buff, offset RBuff
        call     AsciiToBase
         mov     eax, Work
      .if R5+4 >= eax
            sub     R5+4, eax                       ; Adjust the number of decimals
      .endif
        call     Prep

      .if BPress == 3
           call     MulMW
         INVOKE     CopyMW, offset R, offset R3, 4
      .elseif BPress == 4
           call     DivMW
         INVOKE     CopyMW, offset R, offset R2, 4
      .endif
         mov     eax, R5+32
         mov     ebx, R5+36
         and     R+44, 0
      .if eax != ebx                                ; Minus
            or      R+44, 1
      .endif
        call     BaseToAscii

      INVOKE     lstrlen, offset ConvI
         mov     ecx, eax
         mov     ebx, eax
         mov     edx, eax
         xor     esi, esi
         xor     edi, edi
      .if BPress == 3
            mov     ecx, R5
            add     ecx, R5+4
            sub     eax, R5
            sub     eax, R5+4
            mov     R5, ecx      ; !!!!!!!!!!
      .elseif BPress == 4

FindDec:                                            ; Find decimel in Quotient
            mov     bl, byte ptr ConvI[esi]
         .if bl == 2eh
               mov     ecx, esi 
               inc     esi
               jmp     FindDec
         .endif
            inc     esi
            cmp     bl, 0h
            jne     FindDec
            mov     ebx, ecx     ; Decimal position, length of Quotient whole number

         .if ecx >= R5
               sub     ecx, R5
         .else
               mov     ecx, R5
         .endif
            mov     eax, ecx
            sub     ecx, ebx
            inc     ecx
      .endif
         xor     esi, esi
         xor     edi, edi
      .if ebx >= R5                                 ; No zero pad
            jmp     Loop1
      .endif
      .if BPress == 3
            sub     ecx, ebx
            inc     ecx
      .endif
         mov     byte ptr ConvO[edi], 2eh
         mov     Sav, edi
         add     edi, ecx
        push     edi
        push     esi   
      INVOKE     lstrcpyn, offset ConvO+1, offset Zeros, ecx
         pop     esi
         pop     edi
         xor     eax, eax

Loop1:                                              ; Shift right
         mov     bl, byte ptr ConvI[esi]
      .if bl == 2eh
            inc     esi
            jmp     Loop1
      .endif
      .if eax == edi
            mov     byte ptr ConvO[edi], 2eh
            mov     Sav, edi
            inc     edi
      .endif
         mov     byte ptr ConvO[edi], bl
         inc     edi
         inc     esi
         cmp     bl, 0h
         jne     Loop1
         mov     sw1, 0

      INVOKE     lstrcpy, offset Buff, offset ConvO
        call     AsciiToBase
        call     BaseToAscii
         mov     ebx, offset ConvO
         add     ebx, Sav
        call     Fixem
         pop     ebx
         pop     esi
         pop     edi
         RET
ShiftDec ENDP

;=========================================================================|
;         Stores the current input and performs the basic math            |
;                      functions for running totals.                      |
;=========================================================================|
StoreCLR PROC
      .if First == 0
         INVOKE     SendMessage, hEdit, WM_GETTEXT, 35, offset ConvH
CopyIt:
         INVOKE     lstrcpy, offset HLBuff, offset LBuff
         INVOKE     lstrcpy, offset HRBuff, offset RBuff
         INVOKE     lstrlen, offset RBuff
            mov     HLen, eax
         INVOKE     CopyMW, offset PT, offset R, 12
            cmp     sw1, 3
            je      ClrDsply
            fld     RNum10
           fstp     RWrk10
            or      First, 1
      .endif
      .if Float == 0
           call     Prep
         .if BPress == 1
              call     AddEM
               and     BPress, 0
         .elseif BPress == 2
              call     SubEM
               and     BPress, 0
         .elseif BPress == 3
              call     MulEM
               and     BPress, 0
         .elseif BPress == 4 && Buff != 0
              call     DivEM
               and     BPress, 0
         .endif
         INVOKE     lstrcpy, offset Buff, offset ConvO
           call     AsciiToBase
           call     BaseToAscii
;DSPValue hWnd, R+40
;INVOKE     MessageBox,NULL, addr ConvO, addr AppName, MB_OK
         INVOKE     lstrcpy, offset ConvH, offset ConvO
            or      sw1, 3
            jmp     CopyIt
      .endif

       finit
         fld     RNum10
         fld     RWrk10
      .if BPress == 1
           fadd     ST(0), ST(1)
            and     BPress, 0
      .elseif BPress == 2
           fsub     ST(0), ST(1)
            and     BPress, 0
      .elseif BPress == 3
           fmul     ST(0), ST(1)
            and     BPress, 0
      .elseif BPress == 4 && R+12 > 0 || BPress == 4 && R+28 > 0
           fdiv     ST(0), ST(1)
            and     BPress, 0
      .endif
           fstp     RWrk10

ClrDsply:
         mov     ConvO, 0
      INVOKE     SendMessage, hEdit, WM_SETTEXT, NULL, offset ConvO
         and     sw1, 0
         and     DP, 0
         RET
StoreCLR ENDP

;=========================================================================|
;               Adjusts the decimals numbers and Prepare                  |
;                   the input for the math functions.                     |
;=========================================================================|
Prep    PROC     ; Sets the base power for the decimal number
            .if BPress == 1 || BPress == 2
                  mov     R5+32, 1
                MOVmd     R5+36, PT+44
               INVOKE     CompMW, offset PT, offset R, 8
               .if eax == 2                      ; For add & sub flip A & B if B > A
                  INVOKE     CopyMW, offset Sav, offset R, 12
                  INVOKE     CopyMW, offset R, offset PT, 12
                  INVOKE     CopyMW, offset PT, offset Sav, 12
                  INVOKE     lstrcpy, offset ConvH, offset ConvO
                  INVOKE     lstrcpy, offset HLBuff, offset LBuff
                  INVOKE     lstrcpy, offset HRBuff, offset RBuff
                    call     BaseToAscii
                  INVOKE     lstrlen, offset HRBuff
                     mov     HLen, eax
                     mov     R5+32, 0
                   MOVmd     R5+36, R+44 
               .endif  
            .endif 

      .if PT+36 > 0 || R+36 > 0
            INVOKE     CLRMW, offset A, 16
               mov     A+12, 1
             MOVmd     B+12, HBase
               mov     eax, R+36
         .if PT+36 > eax
               mov     ecx, PT+36
               sub     ecx, eax
               jmp     LoopA
         .elseif PT+36 < eax
               mov     ecx, eax
               sub     ecx, PT+36
LoopA:
              call     MulMW
            INVOKE     CopyMW, offset A, offset R3, 4
              loop     LoopA

            .if PT+36 < eax
               INVOKE     CopyMW, offset B, offset PT+16, 4
            .else
               INVOKE     CopyMW, offset B, offset R+16, 4
            .endif
              call     MulMW
            .if PT+36 < eax
               INVOKE     CopyMW, offset PT+16, offset R3, 4
            .else
               INVOKE     CopyMW, offset R+16, offset R3, 4
            .endif
         .endif
         
         .if BPress != 4  ; ?????????????????????????????????
               mov     edx, R+40
            .if PT+40 > edx
            .else
                MOVmd     R+40, PT+40
            .endif
         .endif
      .endif
      INVOKE     CopyMW, offset A, offset PT, 8
      INVOKE     CopyMW, offset B, offset R, 8
         RET
Prep     ENDP

;=========================================================================|
;                          Adds multiple dwords.                          |
;=========================================================================|
AddMW PROC
         cmp     PassDec, 1 
         je      Pass
         mov     eax, A+28
         add     eax, B+28
         mov     R+28, eax
         mov     eax, A+24
         adc     eax, B+24
         mov     R+24, eax
         mov     eax, A+20
         adc     eax, B+20
         mov     R+20, eax
         mov     eax, A+16
         adc     eax, B+16
         mov     R+16, eax
Pass:
         mov     eax, A+12
         add     eax, B+12
         mov     R+12, eax
         mov     eax, A+8
         adc     eax, B+8
         mov     R+8, eax
         mov     eax, A+4
         adc     eax, B+4
         mov     R+4, eax
         mov     eax, A
         adc     eax, B
         mov     R, eax
         RET
AddMW ENDP

;********************************************************************************************
AddNewMWp PROC
Loop1:
         mov     eax, A[edx]
         adc     eax, B[edx]
         ;add     eax, B[edx]
         mov     R[edx], eax
         sub     edx, 4
        loop     Loop1
         RET
AddNewMWp ENDP

;=========================================================================|
;                       Subtracts multiple dwords.                        |
;=========================================================================|
SubMW PROC
         cmp     PassDec, 1 
         je      Pass
         mov     eax, A+28
         sub     eax, B+28
         mov     R+28, eax
         mov     eax, A+24
         sbb     eax, B+24
         mov     R+24, eax
         mov     eax, A+20
         sbb     eax, B+20
         mov     R+20, eax
         mov     eax, A+16
         sbb     eax, B+16
         mov     R+16, eax
Pass:
         mov     eax, A+12
         sub     eax, B+12
         mov     R+12, eax
         mov     eax, A+8
         sbb     eax, B+8
         mov     R+8, eax
         mov     eax, A+4
         sbb     eax, B+4
         mov     R+4, eax
         mov     eax, A
         sbb     eax, B
         mov     R, eax

         and     eax, 80000000h
         cmp     eax, 80000000h
         jnz     PlusNum
      INVOKE     CopyMW, offset A, offset B, 8
      INVOKE     CopyMW, offset B, offset PT, 8
        call     SubMW
PlusNum: 
         RET
SubMW ENDP

;=========================================================================|
;   Floating point divide used if the divisor is greater then one dword.  |
;=========================================================================|
FPDivMW  PROC
       finit
         fld     RNum10
         fld     RWrk10
        fdiv     ST(0), ST(1)
        fstp     RNum10
         fld     RNum10
        fstp     RWrk10
         mov     edx, offset RNum10
      .if !RPress
         or      NoFix, 1
      .endif
        call     FloatToAscii
         and     NoFix, 0
         RET
FPDivMW  ENDP

;********************************************************************************************
SubNewMWp PROC
Loop1:
         mov     eax, A[edx]
         sbb     eax, B[edx]
         mov     R[edx], eax
         sub     edx, 4
        loop     Loop1
         RET
SubNewMWp ENDP

;=========================================================================|
;                      Multiplies multiple dwords.                        |
;=========================================================================|
MulMW   PROC
      pushad
; Multiply B+12 dword of Multiplier times A+12 & A+8 & A+4 & A:
         mov     eax, B+12   ;
         mov     ebx, eax    ; Save Multiplier val
         mul     A+12        ; Multiply L.O. dwords
         mov     R3+12, eax  ; Save partial product
         mov     ecx, edx    ; Save H.O. dword

         mov     eax, ebx    ; Get Multiplier in ebx
         mul     A+8         ; Multiply B+12 * A+8.
         add     eax, ecx    ; Add partial product
         adc     edx, 0      ; Don't forget carry!
         mov     ebx, eax    ; Save partial product
         mov     ecx, edx    ;  for now.

         mov     eax, B+12   ; Get Multiplier in B+12
         mul     A+4         ; Multiply B+12 * A+4.
         add     eax, ecx    ; Add partial product
         adc     edx, 0      ; Don't forget carry!
         mov     w1, eax     ; Save partial product
         mov     ecx, edx    ;  for now.

         mov     eax, B+12   ; Get Multiplier in B+12
         mul     A           ; Multiply B+12 * A.
         add     eax, ecx    ; Add partial product
         adc     edx, 0      ; Don't forget carry!
         mov     w2, eax     ; Save partial product
         mov     ecx, 0 ;edx    ; for now.

; Multiply B+8 dword of Multiplier times A+12 & A+8 & A+4 & A:
         mov     eax, B+8    ; Get B+8. Multiplier
         mul     A+12        ; Times A+12. dword
         add     eax, ebx    ; Add partial product
         mov     R3+8, eax   ; Save partial product
         adc     ecx, edx    ; Add in carry/B+8!

         mov     eax, B+8    ; Multiply the B+8.
         mul     A+8         ; words together.
         add     eax, ecx
        push     edx
         adc     edx, w2     ; works if B > A    Don't forget carry!
         mov     ebx, edx
         pop     edx
         add     eax, w1     ; Add partial product
         mov     R3+4, eax   ; Save partial product
         adc     edx, w2     ; works if A > B    Don't forget carry!
         mov     R3, ebx
      .if w1 > ecx    
            mov     R3, edx
      .endif
       popad
         RET
MulMW    ENDP

;=========================================================================|
;                         Divides multiple dwords.                        |
;=========================================================================|
DivMW   PROC
push     ecx
      .if B+12 == 00000000h
            jmp     DivRet
      .endif   
         xor     edx, edx
         mov     eax, A       ; Dividend
         div     B+12         ; Divisor
         mov     R2, eax      ; Quotient
         mov     eax, A+4
         div     B+12
         mov     R2+4, eax
         mov     eax, A+8
         div     B+12
         mov     R2+8, eax
         mov     eax, A+12
         div     B+12
         mov     R2+12, eax

         cmp     R5+24, 1
         je      DivRet       ; From BaseToAscii no need to find decimals
         xor     ecx, ecx
         mov     HRBuff, 0h
         mov     eax, edx
Loop1:
      .if edx > 0 && ecx < 19 ;16  ;12  ;24
            inc     ecx
            mov     eax, edx
            mul     Base
            mov     Sav+8, edx
            mov     Sav+12, eax 
            xor     edx, edx
            mov     eax, Sav+8
            div     B+12
            mov     eax, Sav+12
            div     B+12
            mov     sesi, ecx
            mov     sedi, edx
           push     eax
         .if Base == 16
               push     offset FmtH
         .else
               push     offset FmtA
         .endif
           push     offset ConvI
           call     wsprintfA
            add     esp, 12
         INVOKE     lstrcat, offset HRBuff, offset ConvI
            mov     edx, sedi
            mov     ecx, sesi
            jmp     Loop1
      .endif
      .if ecx > 0
         INVOKE     lstrcat, offset HRBuff, 0h
            mov     ebx, offset HRBuff
           call     Fixem
            mov     byte ptr Buff, 2eh
         INVOKE     lstrcpy, offset Buff+1, offset HRBuff
         INVOKE     CopyMW, offset PT, offset R2, 4
           call     AsciiToBase
           call     BaseToAscii
         INVOKE     CopyMW, offset R2, offset PT, 4
         .if sedi > 0 
               add     R+28, 1
         .endif
      .endif
DivRet:
pop      ecx
         RET
DivMW   ENDP

;=========================================================================|
;              Computes X to the Nth power intergers only.                |
;=========================================================================|
PowerN  PROC
      INVOKE     CLRMW, offset A, 16
      INVOKE     CLRMW, offset R+16, 4
       MOVmd     B+12, PT+12
       MOVmd     R3+12, 1
         mov     ecx, R+12
Power:
      INVOKE     CopyMW, offset A, offset R3, 4
        call     MulMW
        loop     Power
      INVOKE     CopyMW, offset R, offset R3, 4
        call     BaseToAscii
         RET
PowerN  ENDP

;=========================================================================|
;                        Computes 2 to the Nth power.                     |
;=========================================================================|
TwoX    PROC
       fldcw     CWNoRound
         fld     st(0)        ; Duplicate tos.
         fld     st(0)
     frndint                  ; Compute integer portion.
        fxch                  ; Swap whole and int values.
        fsub     st(0), st(1) ; Compute fractional part.
       f2xm1                  ; Compute 2**frac(x)-1.
        fld1                  ; Load 1
        fadd                  ; Compute 2**frac(x).
        fxch                  ; Get integer portion.
        fld1                  ; Compute 1*2**int(x).
      fscale
        fstp     st(1)        ; Remove st(1) (which is 1).
        fmul                  ; Compute 2**int(x) * 2**frac(x).
       fldcw     CWRound      ; Restore rounding mode.
         fld     ST(0)      
        fstp     RNum10
         RET
TwoX    ENDP

;=========================================================================|
;                      Computes 10 to the Nth power.                      |
;=========================================================================|
TenX    PROC
      fldl2t                  ; Put lg(10) onto the stack
        fmul                  ; Compute x*lg(10)
        call     TwoX         ; Compute 2**(x * lg(10)).
         RET
TenX    ENDP

;=========================================================================|
;                      Computes e to the Nth power.                       |
;=========================================================================|
ExpX    PROC
      fldl2e                  ; Put lg(e) onto the stack.
        fmul                  ; Compute x*lg(e).
        call     TwoX         ; Compute 2**(x * lg(e)).
         RET  
ExpX    ENDP

;=========================================================================|
;             Rounds and removes excess zeros after Mul, Div              |
;                     or floating point operations.                       |
;=========================================================================|
Fixem   PROC  uses ebx
         mov     edx, ebx
         inc     edx
        push     ebx
      INVOKE     CompareString, LOCALE_USER_DEFAULT, NORM_IGNORECASE, edx, 9, offset Zeros, 9
         pop     ebx
      .if eax == 2 && !RPress ;&& ebx >= cnt          ; 2 = match remove excess zeros 
            mov     byte ptr [ebx], 0    ; Terminate string
      .endif
         cmp     Float, 1
         je      Pass
         mov     Pos, 0
        push     ebx
      INVOKE     lstrlen, ebx
         pop     ebx
         mov     ecx, eax
         xor     edx, edx
      .while (ecx)
         .if byte ptr [ebx] == 30h
            .if Pos == 0
               mov     edx, ebx
               or      Pos, 1
            .endif
         .else
               xor     edx, edx
         .endif
            inc     ebx
            dec     ecx
      .endw
      .if edx > 0
               mov     byte ptr [edx], 0    ; Terminate string
      .endif
Pass:
         inc     ebx
        push     ebx         
      INVOKE     lstrlen, ebx
         pop     ebx   
      .if eax == 0
            jmp     Exit
      .endif
         mov     ecx, eax 
         add     ebx, 1
         sub     ecx, 1
         mov     cnt, ebx
         add     cnt, 1 ; '2' removes (7) 0's after ., '3' removes (8) 0's after .
      .while (ecx)
           push     ebx  
           push     ecx
         INVOKE     CompareString, LOCALE_USER_DEFAULT, NORM_IGNORECASE, ebx, 9, offset Zeros, 9
            pop     ecx
            pop     ebx 
         .if eax == 2 && ebx > cnt          ; 2 = match remove excess zeros
Again:
            .if byte ptr [ebx]-1 == 30h
                  dec     ebx
                  jmp     Again
            .endif
               mov     byte ptr [ebx], 0    ; Terminate string
            .if byte ptr [ebx]-1 == 2eh
               mov     byte ptr [ebx]-1, 0  ; Terminate string
            .endif
               jmp     Exit
         .endif
         .if ((byte ptr [ebx]-1 != '9')\
           && (byte ptr [ebx]+0 == '9')\
           && (byte ptr [ebx]+1 == '9'))
               inc     byte ptr [ebx]-1     ; + 1
               mov     byte ptr [ebx], 0    ; Terminate string
            .break                          ; Exit loop
         .endif
         ;.if ((byte ptr [ebx]-3 != '9')\
         ;  && (byte ptr [ebx]-2 == '.')\
         ;  && (byte ptr [ebx]-1 == '9')\
         ;  && (byte ptr [ebx]+0 >= '5'))
         ;      inc     byte ptr [ebx]-3     ; + 1 rounds to the left of the dec point
         ;      mov     byte ptr [ebx]-2, 0  ; Terminate string
         ;   .break                          ; Exit loop
         ;.endif
            dec     ecx                     ; Continue
            inc     ebx
      .endw
Exit:
         RET
Fixem   ENDP

;=========================================================================|
;          Displays the four bases on the left side of the calc.          |
;=========================================================================|
Display  PROC  uses ebx edx esi edi
LOCAL            rect: RECT
LOCAL            LBuffa[120]: BYTE, RBuffa[120]: BYTE, PLBuffa[120]: BYTE, PRBuffa[120]: BYTE

      INVOKE     CopyMW, offset Sav, offset R, 12
         mov     Col, 0
      INVOKE     GetDC, hDspl
         mov     hEDC, eax

      INVOKE     GetClientRect, hDspl, ADDR rect
         add     rect.left, 2
         add     rect.top, 10
         sub     rect.right, 2
         sub     rect.bottom, 2
;;;      INVOKE     CreateSolidBrush, BackGC               ;Build a solid color brush
      INVOKE     FillRect, hEDC, ADDR rect, hBrush        ;Fill the rectangle with the brush

      INVOKE     SetBkColor, hEDC, BackGC
      INVOKE     SetTextColor, hEDC, HeadC
      INVOKE     TextOut, hEDC, 64, 10, ADDR DecT, 3
      INVOKE     TextOut, hEDC, 64, 40, ADDR HexT, 3
      INVOKE     TextOut, hEDC, 64, 70, ADDR OctT, 3
      INVOKE     TextOut, hEDC, 64, 100, ADDR BinT, 3

;;;      INVOKE     CreateFont,14,8,0,0,500,0,0,0,OEM_CHARSET,\
;;;                 OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,\
;;;                 DEFAULT_QUALITY,DEFAULT_PITCH or FF_MODERN, ADDR FontName
      INVOKE     SelectObject, hEDC, hFontDL
      INVOKE     SetTextColor, hEDC, TextC
         mov     rect.left, 4

;****************************************************
; display Dec
       MOVmd     PrevBase, Base
         or      I, 1
         mov     sw2, 10    ; Not used in DsplyConv
      .if Float == 1    
           call     DsplyConv
      .else
           call     BaseToAscii
      .endif
      INVOKE     lstrlen, offset ConvO
      .if eax > 22
            mov     eax, 22
      .endif
         and     sw2, 0
      ;INVOKE     TextOut, hEDC, 4, 24, ADDR ConvO, eax
         mov     rect.top, 24
         mov     rect.bottom, 36 ;34
      INVOKE     DrawText, hEDC, ADDR ConvO, -1, ADDR rect, DT_LEFT or DT_SINGLELINE
      ;INVOKE     DrawText, hEDC, ADDR ConvO, -1, ADDR rect, DT_LEFT or DT_EDITCONTROL or\
;                 DT_NOCLIP or DT_WORDBREAK

;****************************************************
; display Hex
         mov     sw2, 16
      .if Float == 1    
           call     DsplyConv
      .else
           call     BaseToAscii
      .endif
      INVOKE     lstrlen, offset ConvO
      .if eax > 22
            mov     eax, 22
      .endif
         and     sw2, 0
      ;INVOKE     TextOut, hEDC, 4, 54, ADDR ConvO, eax
         mov     rect.top, 54
         mov     rect.bottom, 66 ;64
      INVOKE     DrawText, hEDC, ADDR ConvO, -1, ADDR rect, DT_LEFT or DT_SINGLELINE

;****************************************************
;display Oct
         mov     sw2, 8
      .if Float == 1    
           call     DsplyConv
      .else
           call     BaseToAscii
      .endif
      INVOKE     lstrlen, offset ConvO
      .if eax > 22
            mov     eax, 22
      .endif
         and     sw2, 0
      ;INVOKE     TextOut, hEDC, 4, 84, ADDR ConvO, eax
         mov     rect.top, 84
         mov     rect.bottom, 96 ;94
      INVOKE     DrawText, hEDC, ADDR ConvO, -1, ADDR rect, DT_LEFT or DT_SINGLELINE


;****************************************************
; display Bin
         mov     sw2, 2
      .if Float == 1    
           call     DsplyConv
          MOVmd     R+40, FPLZ
      .else
           call     BaseToAscii
      .endif
         and     sw2, 0
         mov     YP, 114
         mov     RBuffa, 0h
      INVOKE     lstrlen, ADDR ConvO
         mov     ecx, eax
         mov     esi, offset ConvO
         lea     edi, LBuffa

      .while (ecx)
         .if byte ptr[esi] == 2eh
               mov     byte ptr[edi], 0h
               lea     edi, RBuffa
               inc     esi
               dec     ecx
         .endif    
            mov     bl, byte ptr[esi]
            mov     byte ptr[edi], bl
            inc     edi
            inc     esi
            dec     ecx
            mov     byte ptr[edi], 0h
      .endw

         mov     byte ptr PLBuffa, 0h
         mov     byte ptr PRBuffa, 0h
         lea     esi, LBuffa
         lea     edi, PLBuffa
      INVOKE     lstrlen, ADDR LBuffa
         mov     ecx, 2

      .while (ecx)
         xor     edx, edx 
         mov     ebx, 4
         div     ebx
         sub     ebx, edx
         inc     ebx
         .if edx == 0
               xor     ebx, ebx
         .endif
           push     ecx
         .if ecx == 1
            .if R+40 > 0 && edx == 0
                  inc     ebx
            .endif
               mov     eax, 4
               mul     R+40           ; Leading zeros
               add     ebx, eax
               sub     ebx, R+40
        .endif
         INVOKE     lstrcpyn, edi, offset Zeros, ebx
         INVOKE     lstrcat, edi, esi
            lea     esi, RBuffa
            lea     edi, PRBuffa
         INVOKE     lstrlen, ADDR RBuffa
            mov     Len, eax
            pop     ecx
            dec     ecx
         .if eax > 0
               sub     eax, R+40
         .endif
      .endw

      INVOKE     lstrcpy, ADDR Buff, ADDR PLBuffa
      .if Len > 0
         INVOKE     lstrcat, ADDR Buff, ADDR Period
         INVOKE     lstrcat, ADDR Buff, ADDR PRBuffa
      .endif
      INVOKE     lstrlen, ADDR Buff
         mov     Len, eax
         xor     ebx, ebx
         xor     edx, edx
         xor     edi, edi
         mov     ecx, Len
         cmp     ecx, 0
         je      GetOut
      .if ecx > 112
            mov     ecx, 112
      .endif
Loop1:
         mov     al, byte ptr Buff[ebx]
         mov     byte ptr ConvO[edi], al
         inc     edx
         inc     edi
         inc     ebx
      .if al == 2eh
            dec     edx
            sub     edi, 2
            mov     byte ptr ConvO[edi], 2eh
            inc     edi
      .endif

      .if edx == 4 && ecx > 1
            add     Col, 1
         .if al != 2eh
               mov     byte ptr ConvO[edi], 20h
         .endif 
           push     ecx
push     edi
         ;INVOKE     TextOut, hEDC, 4, YP, ADDR ConvO, edi
          MOVmd     rect.top, YP
          MOVmd     rect.bottom, YP
            add     rect.bottom, 12 ;10
         INVOKE     DrawText, hEDC, ADDR ConvO, edi, ADDR rect, DT_LEFT or DT_SINGLELINE
pop     edi 
            pop     ecx
         .if Col == 4
            .if byte ptr Buff[ebx] == 2eh
                  mov     byte ptr ConvO[edi], 2eh
                  inc     edi
                 push     ecx
push     edi
               ;INVOKE     TextOut, hEDC, 4, YP, ADDR ConvO, edi
                MOVmd     rect.top, YP
                MOVmd     rect.bottom, YP
                  add     rect.bottom, 12 ;10
               INVOKE     DrawText, hEDC, ADDR ConvO, edi, ADDR rect, DT_LEFT or DT_SINGLELINE
pop     edi
                  pop     ecx
            .endif
               mov     Col, 0
               add     YP, 11
               xor     edi, edi
               dec     edi
         .endif
            xor     edx, edx
            inc     edi
      .endif
         dec     ecx
         jnz     Loop1
      ;INVOKE     TextOut, hEDC, 4, YP, ADDR ConvO, edi
       MOVmd     rect.top, YP
       MOVmd     rect.bottom, YP
         add     rect.bottom, 12 ;10
      INVOKE     DrawText, hEDC, ADDR ConvO, edi, ADDR rect, DT_LEFT or DT_SINGLELINE
GetOut: 
      INVOKE     ReleaseDC, hWnd, hEDC
         mov     Col, 0
         and     I, 0
      INVOKE     CopyMW, offset R, offset Sav, 12
       MOVmd     Base, PrevBase
         RET
Display  ENDP

;=========================================================================|
;           Used to convert the display or input to Dsplay PROC.          |
;=========================================================================|
DsplyConv PROC
      .if Float == 0
           call     BaseToAscii
            jmp     NoDec
      .endif
         or      cpy, 8
      INVOKE     lstrcpy, offset Buff, offset PLBuff
        push     Base
       MOVmd     Base, PrevBase
        call     AsciiToBase
         pop     Base  
        call     BaseToAscii
      INVOKE     lstrcpy, offset ConvO, offset ConvI
      .if I != 1                    ; I = 1 comes from display, I = 0 comes from convert base                    
         INVOKE     lstrcpy, offset PLBuff, offset ConvI
      .endif
      INVOKE     lstrlen, offset PRBuff
         cmp     eax, 0
         je      NoDec
      INVOKE     lstrlen, offset ConvI
      INVOKE     lstrcat, offset ConvO, offset Period

      INVOKE     lstrcpy, offset Buff, offset PRBuff + 1
        push     Base
       MOVmd     Base, PrevBase
        call     AsciiToBase
         pop     Base  
        call     BaseToAscii
         xor     ebx, ebx
LoopA:                              ; Insert proper number of zeros after the decimal place 
      .if byte ptr PRBuff[ebx+1] == 30h      
         INVOKE     lstrcat, offset ConvO, offset Zero
            inc     ebx
            jmp     LoopA
      .endif
      INVOKE     lstrcat, offset ConvO, offset ConvI
      .if I != 1                    ; I = 1 comes from display, I = 0 comes from convert base
         INVOKE     lstrcpy, offset PRBuff, offset Period
         INVOKE     lstrcat, offset PRBuff, offset ConvI
      .endif
NoDec:
      .if I != 1                    ; I = 1 comes from display, I = 0 comes from convert base
         INVOKE     SendMessage, hEdit, WM_SETTEXT, NULL, offset ConvO
         INVOKE     SendMessage, hEdit, EM_SETSEL, 33, 33
         INVOKE     SetFocus, hWnd
      .endif
         and     sw2, 0
         and     cpy, 0
        RET
DsplyConv ENDP

;=========================================================================|
;     Converts ascii string of Dec, Hex, Oct or Bin to a REAL10 value.    |
;=========================================================================|
AsciiToFloat PROC
      pushad
         and     Min, 0
      INVOKE     lstrlen, ADDR Buff ; Input
         cmp     eax, 0
         je      GetOut
         xor     ecx, ecx

         mov     edx, offset Buff
      .while (eax)
      .if byte ptr [edx] > 60h
            sub     byte ptr [edx], 57h
      .elseif byte ptr [edx] > 40h
            sub     byte ptr [edx], 37h
      .elseif byte ptr [edx] == 2eh
            mov     byte ptr [edx], 2eh
      .elseif byte ptr [edx] == 2dh
            or     Min, 1
      .else
            sub     byte ptr [edx], 30h
      .endif
         inc     ecx
         inc     edx
         dec     eax
      .endw

      .if ecx == 0
            inc     ecx
      .endif    
         mov     ebx, offset Buff  ; Ascii string
         mov     esi, ebx
         add     esi, ecx          ; Set esi at the end of Buff
         dec     esi
      .if Min == 1
            dec     ecx
            inc     ebx
      .endif 
       finit
        fldz                       ; Initialize ST(0) = 0

Loop1:                             ; Loop before the decimal point
         xor     eax, eax          ; Set eax=0 for later
         mov     al, byte ptr[ebx]
         inc     ebx
         cmp     al, '.'
         je      Loop2
         mov     Work, eax         ; Set Work to number for loading
        fild     Base              ; Load base for adding next digit
       fmulp     ST(1), ST         ; ST(1)=ST(1)*ST & pop ST(0)
        fild     Work              ; Load Work integer to ST(0)
       faddp     ST(1), ST         ; ST(1)=ST(1)+ST & pop ST(0)
        loop     Loop1             ; Next part of loop
        fldz                       ; Load a zero for decimal places
         jmp     NoMore            ; No more characters

Loop2:                             ; Now esi is used for an index
        fldz                       ; Load another zero for the decimal portion

Loop3:                             ; The actual loop after the decimal point
         dec     ecx
         jz      NoMore            ; if out of characters or last one was a '.'
         mov     al, byte ptr[esi] ; get next character   *******************
         dec     esi
         mov     Work,eax          ; Store to Work
        fild     Work              ; Load Work
       faddp     ST(1), ST         ; Add new char to old value
        fild     Base              ; Load base
       fdivp     ST(1), ST         ; Divide by base to retain decimal
         jmp     Loop3

NoMore:
       faddp     ST(1), ST         ; Add integer & decimal
      .if Min == 1
           fchs
      .endif
        fstp     tbyte ptr[RNum10] ; Store real
GetOut:
       popad
         RET
AsciiToFloat ENDP

;=========================================================================|
;      Converts a REAL10 value to a Dec, Hex, Oct or Bin ascii string.    |
;=========================================================================|
FloatToAscii  PROC  uses ebx edx esi edi
      INVOKE     CopyMW, offset Sav, offset R, 12
         mov     PLBuff, 0
         mov     PRBuff, 0
         mov     esi, offset PRBuff
         mov     ebx,edx
       fldcw     CWNoRound
         fld     tbyte ptr[ebx]    ; Load number
         fst     Work
         and     Work, 80000000h
         cmp     Work, 80000000h
         jnz     PlusNum
         mov     Work, 1
        fchs                       ; Changes sign

PlusNum:
         fld     ST(0)             ; Duplicate
       fistp     QW
      INVOKE     CLRMW, offset R, 32
       MOVmd     R+8, dword ptr QW+4
       MOVmd     R+12, dword ptr QW
       MOVmd     R+44, Work
         mov     sw3, 1
        call     BaseToAscii
         and     sw3, 0
      INVOKE     lstrcpy, ADDR PLBuff, ADDR ConvO
        fild     QW                ; ST(0) : xxxxx,  ST(1) : xxxxx.yyyyy
       fsubp     ST(1), ST(0)      ; ST(0) = 0.yyyyy
         fst     Work
         cmp     Work, 0
         jz      Buildit           ; No decimal
      INVOKE     lstrlen, ADDR PLBuff
         mov     byte ptr[esi], 2eh
         inc     esi
         mov     dx,sp             ; Save stack pointer
         xor     ecx,ecx
         mov     edi,edx

CalcDec:
        fild     Base              ; Base 10, 16, 8, 2
       fmulp     ST(1), ST(0)
         fld     ST(0)             ; Duplicate
        call     Extend
        fist     Work              ; looks good at this point first int after dec
       fsubp     ST(1), ST(0)
         mov     eax, Work
      .if eax == 19999999h
         mov     ebx, esp
         jmp     GetOut
      .endif
      .if al > 9h
            add     al, 37h        ; Convert to hex ASCII
      .else
            add     al, 30h        ; Convert to dec ASCII
      .endif
         mov     byte ptr[esi], al ; Ascii output
         inc     esi
         inc     ecx
         cmp     ecx, 19 ;20  ;12  ;15
         jnz     CalcDec
         mov     ebx, esp

GetOut:
         mov     edx, edi
         mov     SP, DX            ; Restore SP
         mov     byte ptr[esi], 0h
Buildit:
      INVOKE     lstrcpy, ADDR ConvO, ADDR PLBuff      ; Non decimal number
      INVOKE     lstrcat, ADDR ConvO, ADDR PRBuff      ; Decimal number
        fstp     Work              ; Get rid of ST(0)
         cmp     PRBuff, 0
         je      Exit
      INVOKE     lstrlen, offset PLBuff
      .if eax > 18
         INVOKE     lstrcpy, ADDR ConvO, ADDR ErrorMsg ; Error
            mov     PLBuff, 0
            mov     PRBuff, 0
           fldz
           fstp     RNum10     
            jmp     Exit
      .endif 
         mov     ebx, offset ConvO
         mov     edx, ebx
         add     ebx, eax
      .if RPress == 1
           push     edx
         INVOKE     lstrlen, offset ConvO
            pop     edx
            add     edx, eax
         .if byte ptr [edx]-1 != 39h   
               inc     byte ptr [edx]-1     ; + 1
         .endif
      .endif
      .if (!NoFix)
           call     Fixem
      .endif
      INVOKE     lstrlen, offset PLBuff
         mov     ebx, eax
         inc     ebx
      INVOKE     lstrcpyn, ADDR PLBuff, ADDR ConvO, ebx   ; non decimal number
         dec     ebx
      INVOKE     lstrcpy, ADDR PRBuff, ADDR ConvO[ebx]    ; decimal number
Exit:
      INVOKE     CopyMW, offset R, offset Sav, 12
       MOVmd     FPLZ, R+40
         RET
FloatToAscii  ENDP

;*************************************************************************************      
Extend   PROC
        fild     Base              ; base 10, 16, 8, 2
       fmulp     ST(1), ST(0)
       fistp     w1
         mov     eax, w1
         xor     edx, edx
         div     Base              ; base 10, 16, 8, 2
         mov     w1, eax
        fild     w1
         RET
Extend   ENDP

End DllEntry

;FSTCW     CW
  ;and     CW, 1111001111111111b
  ;or      CW, 0000000000000000b ;To nearest or even
  ;or      CW, 0000010000000000b ;round down
  ;or      CW, 0000100000000000b ;round up
  ;or      CW, 0000110000000000b ;truncate
;FLDCW     CW
